/* Generated by Pyrex 0.9.8.4 on Wed Sep 17 12:10:59 2008 */

#define PY_SSIZE_T_CLEAN
#include "Python.h"
#include "structmember.h"
#ifndef PY_LONG_LONG
  #define PY_LONG_LONG LONG_LONG
#endif
#if PY_VERSION_HEX < 0x02050000
  typedef int Py_ssize_t;
  #define PY_SSIZE_T_MAX INT_MAX
  #define PY_SSIZE_T_MIN INT_MIN
  #define PyInt_FromSsize_t(z) PyInt_FromLong(z)
  #define PyInt_AsSsize_t(o)	PyInt_AsLong(o)
#endif
#ifndef WIN32
  #ifndef __stdcall
    #define __stdcall
  #endif
  #ifndef __cdecl
    #define __cdecl
  #endif
#endif
#ifdef __cplusplus
#define __PYX_EXTERN_C extern "C"
#else
#define __PYX_EXTERN_C extern
#endif
#include <math.h>
#include "sys/types.h"
#include "Programs/brlapi.h"
#include "bindings.h"
#include "stdlib.h"
#include "string.h"


typedef struct {PyObject **p; int i; char *s; long n;} __Pyx_StringTabEntry; /*proto*/

static PyObject *__pyx_m;
static PyObject *__pyx_b;
static int __pyx_lineno;
static char *__pyx_filename;
static char **__pyx_f;

static char __pyx_mdoc[] = "\nThis module implements a set of bindings for BrlAPI, a braille bridge for applications.\n\nThe reference C API documentation is available online http://mielke.cc/brltty/doc/BrlAPIref-HTML, as well as in manual pages.\n\nThis documentation is only a python helper, you should also read C manual pages.\n\nExample : \nimport brlapi\nimport errno\ntry:\n  b = brlapi.Connection()\n  b.enterTtyMode()\n  b.ignoreKeys(brlapi.rangeType_all,[0])\n  b.acceptKeys(brlapi.rangeType_command,[brlapi.KEY_TYPE_CMD|brlapi.KEY_CMD_HOME, brlapi.KEY_TYPE_CMD|brlapi.KEY_CMD_WINUP, brlapi.KEY_TYPE_CMD|brlapi.KEY_CMD_WINDN])\n  b.writeText(\"Press home or winup/dn to continue ... \")\n  key = b.readKey()\n  k = b.expandKeyCode(key)\n  b.writeText(\"Key %ld (%x %x %x %x) !\" % (key, k[\"type\"], k[\"command\"], k[\"argument\"], k[\"flags\"]))\n  b.writeText(None,1)\n  b.readKey()\n  underline = chr(brlapi.DOT7 + brlapi.DOT8)\n  # Note: center() can take two arguments only starting from python 2.4\n  b.write(\n      regionBegin = 1,\n      regionSize = 40,\n      text = u\"Press any key to exit                  \",\n      orMask = \"\".center(21,underline) + \"\".center(19,chr(0)))\n  b.acceptKeys(brlapi.rangeType_all,[0])\n  b.readKey()\n  b.leaveTtyMode()\n\nexcept brlapi.ConnectionError, e:\n  if e.brlerrno == brlapi.ERROR_CONNREFUSED:\n    print \"Connection to %s refused. BRLTTY is too busy...\" % e.host\n  elif e.brlerrno == brlapi.ERROR_AUTHENTICATION:\n    print \"Authentication with %s failed. Please check the permissions of %s\" % (e.host,e.auth)\n  elif e.brlerrno == brlapi.ERROR_LIBCERR and (e.libcerrno == errno.ECONNREFUSED or e.libcerrno == errno.ENOENT):\n    print \"Connection to %s failed. Is BRLTTY really running?\" % (e.host)\n  else:\n    print \"Connection to BRLTTY at %s failed: \" % (e.host)\n  print e\n  print e.brlerrno\n  print e.libcerrno\n";

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name); /*proto*/

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb); /*proto*/

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name); /*proto*/

static PyObject *__Pyx_UnpackItem(PyObject *); /*proto*/
static int __Pyx_EndUnpack(PyObject *); /*proto*/

static PyObject *__Pyx_GetItemInt(PyObject *o, Py_ssize_t i); /*proto*/

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t); /*proto*/

static PyObject *__Pyx_CreateClass(PyObject *bases, PyObject *dict, PyObject *name, char *modname); /*proto*/

static void __Pyx_AddTraceback(char *funcname); /*proto*/

/* Declarations from c_brlapi */


/* Declarations from brlapi */


/* Declarations from implementation of brlapi */

struct __pyx_obj_6brlapi_WriteStruct {
  PyObject_HEAD
  brlapi_writeArguments_t props;
};

struct __pyx_obj_6brlapi_Connection {
  PyObject_HEAD
  brlapi_handle_t *h;
  brlapi_connectionSettings_t settings;
  int fd;
};



static PyTypeObject *__pyx_ptype_6brlapi_WriteStruct = 0;
static PyTypeObject *__pyx_ptype_6brlapi_Connection = 0;

static char __pyx_k1[] = "brlerrno";
static char __pyx_k2[] = "libcerrno";
static char __pyx_k3[] = "gaierrno";
static char __pyx_k4[] = "errfun";
static char __pyx_k5[] = "OperationError";
static char __pyx_k6[] = "__init__";
static char __pyx_k7[] = "host";
static char __pyx_k8[] = "auth";
static char __pyx_k9[] = "couldn't connect to %s with key %s: %s";
static char __pyx_k10[] = "__str__";
static char __pyx_k11[] = "settings";
static char __pyx_k12[] = "unicode";
static char __pyx_k13[] = "encode";
static char __pyx_k14[] = "UTF-8";
static char __pyx_k15[] = "charset";
static char __pyx_k16[] = "ConnectionError";
static char __pyx_k17[] = "displayNumber";
static char __pyx_k18[] = "regionBegin";
static char __pyx_k19[] = "regionSize";
static char __pyx_k20[] = "text";
static char __pyx_k21[] = "attrAnd";
static char __pyx_k22[] = "attrOr";
static char __pyx_k23[] = "cursor";
static char __pyx_k24[] = "displaySize";
static char __pyx_k25[] = "";
static char __pyx_k26[] = "center";
static char __pyx_k27[] = "write";
static char __pyx_k28[] = "type";
static char __pyx_k29[] = "command";
static char __pyx_k30[] = "argument";
static char __pyx_k31[] = "flags";
static char __pyx_k32[] = "Display number DISPLAY_DEFAULT == unspecified";
static char __pyx_k33[] = "Region of display to update, 1st character of display is 1";
static char __pyx_k34[] = "Number of characters held in text, attrAnd and attrOr. For multibytes text, this is the number of multibyte characters. Combining and double-width characters count for 1";
static char __pyx_k35[] = "Text to display";
static char __pyx_k36[] = "CURSOR_LEAVE == don\'t touch, CURSOR_OFF == turn off, 1 = 1st char of display, ...";
static char __pyx_k37[] = "Character set of the text";
static char __pyx_k38[] = "And attributes; applied first";
static char __pyx_k39[] = "Or attributes; applied after ANDing";
static char __pyx_k40[] = "To get authorized to connect, libbrlapi has to tell the BrlAPI server a secret key, for security reasons. This is the path to the file which holds it; it will hence have to be readable by the application.";
static char __pyx_k41[] = "This tells where the BrlAPI server resides : it might be listening on another computer, on any TCP port. It should look like \"foo:1\", which means TCP port number BRLAPI_SOCKETPORTNUM+1 on computer called \"foo\".";
static char __pyx_k42[] = "Returns the Unix file descriptor that the connection uses";
static char __pyx_k43[] = "Get the size of the braille display\n		See brlapi_getDisplaySize(3).";
static char __pyx_k44[] = "Get the complete name of the driver used by BrlTTY\n		See brlapi_getDriverName(3).";
static char __pyx_k45[] = "TTY_DEFAULT";
static char __pyx_k46[] = "DISPLAY_DEFAULT";
static char __pyx_k47[] = "CURSOR_LEAVE";
static char __pyx_k48[] = "CURSOR_OFF";
static char __pyx_k49[] = "rangeType_all";
static char __pyx_k50[] = "rangeType_type";
static char __pyx_k51[] = "rangeType_command";
static char __pyx_k52[] = "rangeType_key";
static char __pyx_k53[] = "rangeType_code";
static char __pyx_k54[] = "ERROR_SUCCESS";
static char __pyx_k55[] = "ERROR_NOMEM";
static char __pyx_k56[] = "ERROR_TTYBUSY";
static char __pyx_k57[] = "ERROR_DEVICEBUSY";
static char __pyx_k58[] = "ERROR_UNKNOWN_INSTRUCTION";
static char __pyx_k59[] = "ERROR_ILLEGAL_INSTRUCTION";
static char __pyx_k60[] = "ERROR_INVALID_PARAMETER";
static char __pyx_k61[] = "ERROR_INVALID_PACKET";
static char __pyx_k62[] = "ERROR_CONNREFUSED";
static char __pyx_k63[] = "ERROR_OPNOTSUPP";
static char __pyx_k64[] = "ERROR_GAIERR";
static char __pyx_k65[] = "ERROR_LIBCERR";
static char __pyx_k66[] = "ERROR_UNKNOWNTTY";
static char __pyx_k67[] = "ERROR_PROTOCOL_VERSION";
static char __pyx_k68[] = "ERROR_EOF";
static char __pyx_k69[] = "ERROR_EMPTYKEY";
static char __pyx_k70[] = "ERROR_DRIVERERROR";
static char __pyx_k71[] = "ERROR_AUTHENTICATION";
static char __pyx_k72[] = "KEY_MAX";
static char __pyx_k73[] = "KEY_FLAGS_MASK";
static char __pyx_k74[] = "KEY_FLAGS_SHIFT";
static char __pyx_k75[] = "KEY_TYPE_MASK";
static char __pyx_k76[] = "KEY_TYPE_SHIFT";
static char __pyx_k77[] = "KEY_TYPE_CMD";
static char __pyx_k78[] = "KEY_TYPE_SYM";
static char __pyx_k79[] = "KEY_CODE_MASK";
static char __pyx_k80[] = "KEY_CODE_SHIFT";
static char __pyx_k81[] = "KEY_CMD_BLK_MASK";
static char __pyx_k82[] = "KEY_CMD_BLK_SHIFT";
static char __pyx_k83[] = "KEY_CMD_ARG_MASK";
static char __pyx_k84[] = "KEY_CMD_ARG_SHIFT";
static char __pyx_k85[] = "KEY_SYM_BACKSPACE";
static char __pyx_k86[] = "KEY_SYM_TAB";
static char __pyx_k87[] = "KEY_SYM_LINEFEED";
static char __pyx_k88[] = "KEY_SYM_ESCAPE";
static char __pyx_k89[] = "KEY_SYM_HOME";
static char __pyx_k90[] = "KEY_SYM_LEFT";
static char __pyx_k91[] = "KEY_SYM_UP";
static char __pyx_k92[] = "KEY_SYM_RIGHT";
static char __pyx_k93[] = "KEY_SYM_DOWN";
static char __pyx_k94[] = "KEY_SYM_PAGE_UP";
static char __pyx_k95[] = "KEY_SYM_PAGE_DOWN";
static char __pyx_k96[] = "KEY_SYM_END";
static char __pyx_k97[] = "KEY_SYM_INSERT";
static char __pyx_k98[] = "KEY_SYM_F1";
static char __pyx_k99[] = "KEY_SYM_F2";
static char __pyx_k100[] = "KEY_SYM_F3";
static char __pyx_k101[] = "KEY_SYM_F4";
static char __pyx_k102[] = "KEY_SYM_F5";
static char __pyx_k103[] = "KEY_SYM_F6";
static char __pyx_k104[] = "KEY_SYM_F7";
static char __pyx_k105[] = "KEY_SYM_F8";
static char __pyx_k106[] = "KEY_SYM_F9";
static char __pyx_k107[] = "KEY_SYM_F10";
static char __pyx_k108[] = "KEY_SYM_F11";
static char __pyx_k109[] = "KEY_SYM_F12";
static char __pyx_k110[] = "KEY_SYM_F13";
static char __pyx_k111[] = "KEY_SYM_F14";
static char __pyx_k112[] = "KEY_SYM_F15";
static char __pyx_k113[] = "KEY_SYM_F16";
static char __pyx_k114[] = "KEY_SYM_F17";
static char __pyx_k115[] = "KEY_SYM_F18";
static char __pyx_k116[] = "KEY_SYM_F19";
static char __pyx_k117[] = "KEY_SYM_F20";
static char __pyx_k118[] = "KEY_SYM_F21";
static char __pyx_k119[] = "KEY_SYM_F22";
static char __pyx_k120[] = "KEY_SYM_F23";
static char __pyx_k121[] = "KEY_SYM_F24";
static char __pyx_k122[] = "KEY_SYM_F25";
static char __pyx_k123[] = "KEY_SYM_F26";
static char __pyx_k124[] = "KEY_SYM_F27";
static char __pyx_k125[] = "KEY_SYM_F28";
static char __pyx_k126[] = "KEY_SYM_F29";
static char __pyx_k127[] = "KEY_SYM_F30";
static char __pyx_k128[] = "KEY_SYM_F31";
static char __pyx_k129[] = "KEY_SYM_F32";
static char __pyx_k130[] = "KEY_SYM_F33";
static char __pyx_k131[] = "KEY_SYM_F34";
static char __pyx_k132[] = "KEY_SYM_F35";
static char __pyx_k133[] = "KEY_SYM_DELETE";
static char __pyx_k134[] = "KEY_SYM_UNICODE";
static char __pyx_k135[] = "KEY_CMD_NOOP";
static char __pyx_k136[] = "KEY_CMD_LNUP";
static char __pyx_k137[] = "KEY_CMD_LNDN";
static char __pyx_k138[] = "KEY_CMD_WINUP";
static char __pyx_k139[] = "KEY_CMD_WINDN";
static char __pyx_k140[] = "KEY_CMD_PRDIFLN";
static char __pyx_k141[] = "KEY_CMD_NXDIFLN";
static char __pyx_k142[] = "KEY_CMD_ATTRUP";
static char __pyx_k143[] = "KEY_CMD_ATTRDN";
static char __pyx_k144[] = "KEY_CMD_TOP";
static char __pyx_k145[] = "KEY_CMD_BOT";
static char __pyx_k146[] = "KEY_CMD_TOP_LEFT";
static char __pyx_k147[] = "KEY_CMD_BOT_LEFT";
static char __pyx_k148[] = "KEY_CMD_PRPGRPH";
static char __pyx_k149[] = "KEY_CMD_NXPGRPH";
static char __pyx_k150[] = "KEY_CMD_PRPROMPT";
static char __pyx_k151[] = "KEY_CMD_NXPROMPT";
static char __pyx_k152[] = "KEY_CMD_PRSEARCH";
static char __pyx_k153[] = "KEY_CMD_NXSEARCH";
static char __pyx_k154[] = "KEY_CMD_CHRLT";
static char __pyx_k155[] = "KEY_CMD_CHRRT";
static char __pyx_k156[] = "KEY_CMD_HWINLT";
static char __pyx_k157[] = "KEY_CMD_HWINRT";
static char __pyx_k158[] = "KEY_CMD_FWINLT";
static char __pyx_k159[] = "KEY_CMD_FWINRT";
static char __pyx_k160[] = "KEY_CMD_FWINLTSKIP";
static char __pyx_k161[] = "KEY_CMD_FWINRTSKIP";
static char __pyx_k162[] = "KEY_CMD_LNBEG";
static char __pyx_k163[] = "KEY_CMD_LNEND";
static char __pyx_k164[] = "KEY_CMD_HOME";
static char __pyx_k165[] = "KEY_CMD_BACK";
static char __pyx_k166[] = "KEY_CMD_RETURN";
static char __pyx_k167[] = "KEY_CMD_FREEZE";
static char __pyx_k168[] = "KEY_CMD_DISPMD";
static char __pyx_k169[] = "KEY_CMD_SIXDOTS";
static char __pyx_k170[] = "KEY_CMD_SLIDEWIN";
static char __pyx_k171[] = "KEY_CMD_SKPIDLNS";
static char __pyx_k172[] = "KEY_CMD_SKPBLNKWINS";
static char __pyx_k173[] = "KEY_CMD_CSRVIS";
static char __pyx_k174[] = "KEY_CMD_CSRHIDE";
static char __pyx_k175[] = "KEY_CMD_CSRTRK";
static char __pyx_k176[] = "KEY_CMD_CSRSIZE";
static char __pyx_k177[] = "KEY_CMD_CSRBLINK";
static char __pyx_k178[] = "KEY_CMD_ATTRVIS";
static char __pyx_k179[] = "KEY_CMD_ATTRBLINK";
static char __pyx_k180[] = "KEY_CMD_CAPBLINK";
static char __pyx_k181[] = "KEY_CMD_TUNES";
static char __pyx_k182[] = "KEY_CMD_AUTOREPEAT";
static char __pyx_k183[] = "KEY_CMD_AUTOSPEAK";
static char __pyx_k184[] = "KEY_CMD_HELP";
static char __pyx_k185[] = "KEY_CMD_INFO";
static char __pyx_k186[] = "KEY_CMD_LEARN";
static char __pyx_k187[] = "KEY_CMD_PREFMENU";
static char __pyx_k188[] = "KEY_CMD_PREFSAVE";
static char __pyx_k189[] = "KEY_CMD_PREFLOAD";
static char __pyx_k190[] = "KEY_CMD_MENU_FIRST_ITEM";
static char __pyx_k191[] = "KEY_CMD_MENU_LAST_ITEM";
static char __pyx_k192[] = "KEY_CMD_MENU_PREV_ITEM";
static char __pyx_k193[] = "KEY_CMD_MENU_NEXT_ITEM";
static char __pyx_k194[] = "KEY_CMD_MENU_PREV_SETTING";
static char __pyx_k195[] = "KEY_CMD_MENU_NEXT_SETTING";
static char __pyx_k196[] = "KEY_CMD_MUTE";
static char __pyx_k197[] = "KEY_CMD_SPKHOME";
static char __pyx_k198[] = "KEY_CMD_SAY_LINE";
static char __pyx_k199[] = "KEY_CMD_SAY_ABOVE";
static char __pyx_k200[] = "KEY_CMD_SAY_BELOW";
static char __pyx_k201[] = "KEY_CMD_SAY_SLOWER";
static char __pyx_k202[] = "KEY_CMD_SAY_FASTER";
static char __pyx_k203[] = "KEY_CMD_SAY_SOFTER";
static char __pyx_k204[] = "KEY_CMD_SAY_LOUDER";
static char __pyx_k205[] = "KEY_CMD_SWITCHVT_PREV";
static char __pyx_k206[] = "KEY_CMD_SWITCHVT_NEXT";
static char __pyx_k207[] = "KEY_CMD_CSRJMP_VERT";
static char __pyx_k208[] = "KEY_CMD_PASTE";
static char __pyx_k209[] = "KEY_CMD_RESTARTBRL";
static char __pyx_k210[] = "KEY_CMD_RESTARTSPEECH";
static char __pyx_k211[] = "KEY_CMD_OFFLINE";
static char __pyx_k212[] = "KEY_CMD_SHUTDOWN";
static char __pyx_k213[] = "KEY_FLG_TOGGLE_ON";
static char __pyx_k214[] = "KEY_FLG_TOGGLE_OFF";
static char __pyx_k215[] = "KEY_FLG_TOGGLE_MASK";
static char __pyx_k216[] = "KEY_FLG_ROUTE";
static char __pyx_k217[] = "KEY_FLG_REPEAT_INITIAL";
static char __pyx_k218[] = "KEY_FLG_REPEAT_DELAY";
static char __pyx_k219[] = "KEY_FLG_REPEAT_MASK";
static char __pyx_k220[] = "KEY_CMD_ROUTE";
static char __pyx_k221[] = "KEY_CMD_CUTBEGIN";
static char __pyx_k222[] = "KEY_CMD_CUTAPPEND";
static char __pyx_k223[] = "KEY_CMD_CUTRECT";
static char __pyx_k224[] = "KEY_CMD_CUTLINE";
static char __pyx_k225[] = "KEY_CMD_SWITCHVT";
static char __pyx_k226[] = "KEY_CMD_PRINDENT";
static char __pyx_k227[] = "KEY_CMD_NXINDENT";
static char __pyx_k228[] = "KEY_CMD_DESCCHAR";
static char __pyx_k229[] = "KEY_CMD_SETLEFT";
static char __pyx_k230[] = "KEY_CMD_SETMARK";
static char __pyx_k231[] = "KEY_CMD_GOTOMARK";
static char __pyx_k232[] = "KEY_CMD_GOTOLINE";
static char __pyx_k233[] = "KEY_FLG_LINE_SCALED";
static char __pyx_k234[] = "KEY_FLG_LINE_TOLEFT";
static char __pyx_k235[] = "KEY_CMD_PRDIFCHAR";
static char __pyx_k236[] = "KEY_CMD_NXDIFCHAR";
static char __pyx_k237[] = "KEY_CMD_PASSDOTS";
static char __pyx_k238[] = "KEY_FLG_SHIFT";
static char __pyx_k239[] = "KEY_FLG_UPPER";
static char __pyx_k240[] = "KEY_FLG_CONTROL";
static char __pyx_k241[] = "KEY_FLG_META";
static char __pyx_k242[] = "KEY_CMD_PASSAT";
static char __pyx_k243[] = "KEY_CMD_PASSXT";
static char __pyx_k244[] = "KEY_CMD_PASSPS2";
static char __pyx_k245[] = "KEY_FLG_KBD_RELEASE";
static char __pyx_k246[] = "KEY_FLG_KBD_EMUL0";
static char __pyx_k247[] = "KEY_FLG_KBD_EMUL1";
static char __pyx_k248[] = "DOT1";
static char __pyx_k249[] = "DOT2";
static char __pyx_k250[] = "DOT3";
static char __pyx_k251[] = "DOT4";
static char __pyx_k252[] = "DOT5";
static char __pyx_k253[] = "DOT6";
static char __pyx_k254[] = "DOT7";
static char __pyx_k255[] = "DOT8";
static char __pyx_k256[] = "Error while performing some operation";
static char __pyx_k257[] = "Error while connecting to BrlTTY";

static PyObject *__pyx_n_CURSOR_LEAVE;
static PyObject *__pyx_n_CURSOR_OFF;
static PyObject *__pyx_n_ConnectionError;
static PyObject *__pyx_n_DISPLAY_DEFAULT;
static PyObject *__pyx_n_DOT1;
static PyObject *__pyx_n_DOT2;
static PyObject *__pyx_n_DOT3;
static PyObject *__pyx_n_DOT4;
static PyObject *__pyx_n_DOT5;
static PyObject *__pyx_n_DOT6;
static PyObject *__pyx_n_DOT7;
static PyObject *__pyx_n_DOT8;
static PyObject *__pyx_n_ERROR_AUTHENTICATION;
static PyObject *__pyx_n_ERROR_CONNREFUSED;
static PyObject *__pyx_n_ERROR_DEVICEBUSY;
static PyObject *__pyx_n_ERROR_DRIVERERROR;
static PyObject *__pyx_n_ERROR_EMPTYKEY;
static PyObject *__pyx_n_ERROR_EOF;
static PyObject *__pyx_n_ERROR_GAIERR;
static PyObject *__pyx_n_ERROR_ILLEGAL_INSTRUCTION;
static PyObject *__pyx_n_ERROR_INVALID_PACKET;
static PyObject *__pyx_n_ERROR_INVALID_PARAMETER;
static PyObject *__pyx_n_ERROR_LIBCERR;
static PyObject *__pyx_n_ERROR_NOMEM;
static PyObject *__pyx_n_ERROR_OPNOTSUPP;
static PyObject *__pyx_n_ERROR_PROTOCOL_VERSION;
static PyObject *__pyx_n_ERROR_SUCCESS;
static PyObject *__pyx_n_ERROR_TTYBUSY;
static PyObject *__pyx_n_ERROR_UNKNOWNTTY;
static PyObject *__pyx_n_ERROR_UNKNOWN_INSTRUCTION;
static PyObject *__pyx_n_KEY_CMD_ARG_MASK;
static PyObject *__pyx_n_KEY_CMD_ARG_SHIFT;
static PyObject *__pyx_n_KEY_CMD_ATTRBLINK;
static PyObject *__pyx_n_KEY_CMD_ATTRDN;
static PyObject *__pyx_n_KEY_CMD_ATTRUP;
static PyObject *__pyx_n_KEY_CMD_ATTRVIS;
static PyObject *__pyx_n_KEY_CMD_AUTOREPEAT;
static PyObject *__pyx_n_KEY_CMD_AUTOSPEAK;
static PyObject *__pyx_n_KEY_CMD_BACK;
static PyObject *__pyx_n_KEY_CMD_BLK_MASK;
static PyObject *__pyx_n_KEY_CMD_BLK_SHIFT;
static PyObject *__pyx_n_KEY_CMD_BOT;
static PyObject *__pyx_n_KEY_CMD_BOT_LEFT;
static PyObject *__pyx_n_KEY_CMD_CAPBLINK;
static PyObject *__pyx_n_KEY_CMD_CHRLT;
static PyObject *__pyx_n_KEY_CMD_CHRRT;
static PyObject *__pyx_n_KEY_CMD_CSRBLINK;
static PyObject *__pyx_n_KEY_CMD_CSRHIDE;
static PyObject *__pyx_n_KEY_CMD_CSRJMP_VERT;
static PyObject *__pyx_n_KEY_CMD_CSRSIZE;
static PyObject *__pyx_n_KEY_CMD_CSRTRK;
static PyObject *__pyx_n_KEY_CMD_CSRVIS;
static PyObject *__pyx_n_KEY_CMD_CUTAPPEND;
static PyObject *__pyx_n_KEY_CMD_CUTBEGIN;
static PyObject *__pyx_n_KEY_CMD_CUTLINE;
static PyObject *__pyx_n_KEY_CMD_CUTRECT;
static PyObject *__pyx_n_KEY_CMD_DESCCHAR;
static PyObject *__pyx_n_KEY_CMD_DISPMD;
static PyObject *__pyx_n_KEY_CMD_FREEZE;
static PyObject *__pyx_n_KEY_CMD_FWINLT;
static PyObject *__pyx_n_KEY_CMD_FWINLTSKIP;
static PyObject *__pyx_n_KEY_CMD_FWINRT;
static PyObject *__pyx_n_KEY_CMD_FWINRTSKIP;
static PyObject *__pyx_n_KEY_CMD_GOTOLINE;
static PyObject *__pyx_n_KEY_CMD_GOTOMARK;
static PyObject *__pyx_n_KEY_CMD_HELP;
static PyObject *__pyx_n_KEY_CMD_HOME;
static PyObject *__pyx_n_KEY_CMD_HWINLT;
static PyObject *__pyx_n_KEY_CMD_HWINRT;
static PyObject *__pyx_n_KEY_CMD_INFO;
static PyObject *__pyx_n_KEY_CMD_LEARN;
static PyObject *__pyx_n_KEY_CMD_LNBEG;
static PyObject *__pyx_n_KEY_CMD_LNDN;
static PyObject *__pyx_n_KEY_CMD_LNEND;
static PyObject *__pyx_n_KEY_CMD_LNUP;
static PyObject *__pyx_n_KEY_CMD_MENU_FIRST_ITEM;
static PyObject *__pyx_n_KEY_CMD_MENU_LAST_ITEM;
static PyObject *__pyx_n_KEY_CMD_MENU_NEXT_ITEM;
static PyObject *__pyx_n_KEY_CMD_MENU_NEXT_SETTING;
static PyObject *__pyx_n_KEY_CMD_MENU_PREV_ITEM;
static PyObject *__pyx_n_KEY_CMD_MENU_PREV_SETTING;
static PyObject *__pyx_n_KEY_CMD_MUTE;
static PyObject *__pyx_n_KEY_CMD_NOOP;
static PyObject *__pyx_n_KEY_CMD_NXDIFCHAR;
static PyObject *__pyx_n_KEY_CMD_NXDIFLN;
static PyObject *__pyx_n_KEY_CMD_NXINDENT;
static PyObject *__pyx_n_KEY_CMD_NXPGRPH;
static PyObject *__pyx_n_KEY_CMD_NXPROMPT;
static PyObject *__pyx_n_KEY_CMD_NXSEARCH;
static PyObject *__pyx_n_KEY_CMD_OFFLINE;
static PyObject *__pyx_n_KEY_CMD_PASSAT;
static PyObject *__pyx_n_KEY_CMD_PASSDOTS;
static PyObject *__pyx_n_KEY_CMD_PASSPS2;
static PyObject *__pyx_n_KEY_CMD_PASSXT;
static PyObject *__pyx_n_KEY_CMD_PASTE;
static PyObject *__pyx_n_KEY_CMD_PRDIFCHAR;
static PyObject *__pyx_n_KEY_CMD_PRDIFLN;
static PyObject *__pyx_n_KEY_CMD_PREFLOAD;
static PyObject *__pyx_n_KEY_CMD_PREFMENU;
static PyObject *__pyx_n_KEY_CMD_PREFSAVE;
static PyObject *__pyx_n_KEY_CMD_PRINDENT;
static PyObject *__pyx_n_KEY_CMD_PRPGRPH;
static PyObject *__pyx_n_KEY_CMD_PRPROMPT;
static PyObject *__pyx_n_KEY_CMD_PRSEARCH;
static PyObject *__pyx_n_KEY_CMD_RESTARTBRL;
static PyObject *__pyx_n_KEY_CMD_RESTARTSPEECH;
static PyObject *__pyx_n_KEY_CMD_RETURN;
static PyObject *__pyx_n_KEY_CMD_ROUTE;
static PyObject *__pyx_n_KEY_CMD_SAY_ABOVE;
static PyObject *__pyx_n_KEY_CMD_SAY_BELOW;
static PyObject *__pyx_n_KEY_CMD_SAY_FASTER;
static PyObject *__pyx_n_KEY_CMD_SAY_LINE;
static PyObject *__pyx_n_KEY_CMD_SAY_LOUDER;
static PyObject *__pyx_n_KEY_CMD_SAY_SLOWER;
static PyObject *__pyx_n_KEY_CMD_SAY_SOFTER;
static PyObject *__pyx_n_KEY_CMD_SETLEFT;
static PyObject *__pyx_n_KEY_CMD_SETMARK;
static PyObject *__pyx_n_KEY_CMD_SHUTDOWN;
static PyObject *__pyx_n_KEY_CMD_SIXDOTS;
static PyObject *__pyx_n_KEY_CMD_SKPBLNKWINS;
static PyObject *__pyx_n_KEY_CMD_SKPIDLNS;
static PyObject *__pyx_n_KEY_CMD_SLIDEWIN;
static PyObject *__pyx_n_KEY_CMD_SPKHOME;
static PyObject *__pyx_n_KEY_CMD_SWITCHVT;
static PyObject *__pyx_n_KEY_CMD_SWITCHVT_NEXT;
static PyObject *__pyx_n_KEY_CMD_SWITCHVT_PREV;
static PyObject *__pyx_n_KEY_CMD_TOP;
static PyObject *__pyx_n_KEY_CMD_TOP_LEFT;
static PyObject *__pyx_n_KEY_CMD_TUNES;
static PyObject *__pyx_n_KEY_CMD_WINDN;
static PyObject *__pyx_n_KEY_CMD_WINUP;
static PyObject *__pyx_n_KEY_CODE_MASK;
static PyObject *__pyx_n_KEY_CODE_SHIFT;
static PyObject *__pyx_n_KEY_FLAGS_MASK;
static PyObject *__pyx_n_KEY_FLAGS_SHIFT;
static PyObject *__pyx_n_KEY_FLG_CONTROL;
static PyObject *__pyx_n_KEY_FLG_KBD_EMUL0;
static PyObject *__pyx_n_KEY_FLG_KBD_EMUL1;
static PyObject *__pyx_n_KEY_FLG_KBD_RELEASE;
static PyObject *__pyx_n_KEY_FLG_LINE_SCALED;
static PyObject *__pyx_n_KEY_FLG_LINE_TOLEFT;
static PyObject *__pyx_n_KEY_FLG_META;
static PyObject *__pyx_n_KEY_FLG_REPEAT_DELAY;
static PyObject *__pyx_n_KEY_FLG_REPEAT_INITIAL;
static PyObject *__pyx_n_KEY_FLG_REPEAT_MASK;
static PyObject *__pyx_n_KEY_FLG_ROUTE;
static PyObject *__pyx_n_KEY_FLG_SHIFT;
static PyObject *__pyx_n_KEY_FLG_TOGGLE_MASK;
static PyObject *__pyx_n_KEY_FLG_TOGGLE_OFF;
static PyObject *__pyx_n_KEY_FLG_TOGGLE_ON;
static PyObject *__pyx_n_KEY_FLG_UPPER;
static PyObject *__pyx_n_KEY_MAX;
static PyObject *__pyx_n_KEY_SYM_BACKSPACE;
static PyObject *__pyx_n_KEY_SYM_DELETE;
static PyObject *__pyx_n_KEY_SYM_DOWN;
static PyObject *__pyx_n_KEY_SYM_END;
static PyObject *__pyx_n_KEY_SYM_ESCAPE;
static PyObject *__pyx_n_KEY_SYM_F1;
static PyObject *__pyx_n_KEY_SYM_F10;
static PyObject *__pyx_n_KEY_SYM_F11;
static PyObject *__pyx_n_KEY_SYM_F12;
static PyObject *__pyx_n_KEY_SYM_F13;
static PyObject *__pyx_n_KEY_SYM_F14;
static PyObject *__pyx_n_KEY_SYM_F15;
static PyObject *__pyx_n_KEY_SYM_F16;
static PyObject *__pyx_n_KEY_SYM_F17;
static PyObject *__pyx_n_KEY_SYM_F18;
static PyObject *__pyx_n_KEY_SYM_F19;
static PyObject *__pyx_n_KEY_SYM_F2;
static PyObject *__pyx_n_KEY_SYM_F20;
static PyObject *__pyx_n_KEY_SYM_F21;
static PyObject *__pyx_n_KEY_SYM_F22;
static PyObject *__pyx_n_KEY_SYM_F23;
static PyObject *__pyx_n_KEY_SYM_F24;
static PyObject *__pyx_n_KEY_SYM_F25;
static PyObject *__pyx_n_KEY_SYM_F26;
static PyObject *__pyx_n_KEY_SYM_F27;
static PyObject *__pyx_n_KEY_SYM_F28;
static PyObject *__pyx_n_KEY_SYM_F29;
static PyObject *__pyx_n_KEY_SYM_F3;
static PyObject *__pyx_n_KEY_SYM_F30;
static PyObject *__pyx_n_KEY_SYM_F31;
static PyObject *__pyx_n_KEY_SYM_F32;
static PyObject *__pyx_n_KEY_SYM_F33;
static PyObject *__pyx_n_KEY_SYM_F34;
static PyObject *__pyx_n_KEY_SYM_F35;
static PyObject *__pyx_n_KEY_SYM_F4;
static PyObject *__pyx_n_KEY_SYM_F5;
static PyObject *__pyx_n_KEY_SYM_F6;
static PyObject *__pyx_n_KEY_SYM_F7;
static PyObject *__pyx_n_KEY_SYM_F8;
static PyObject *__pyx_n_KEY_SYM_F9;
static PyObject *__pyx_n_KEY_SYM_HOME;
static PyObject *__pyx_n_KEY_SYM_INSERT;
static PyObject *__pyx_n_KEY_SYM_LEFT;
static PyObject *__pyx_n_KEY_SYM_LINEFEED;
static PyObject *__pyx_n_KEY_SYM_PAGE_DOWN;
static PyObject *__pyx_n_KEY_SYM_PAGE_UP;
static PyObject *__pyx_n_KEY_SYM_RIGHT;
static PyObject *__pyx_n_KEY_SYM_TAB;
static PyObject *__pyx_n_KEY_SYM_UNICODE;
static PyObject *__pyx_n_KEY_SYM_UP;
static PyObject *__pyx_n_KEY_TYPE_CMD;
static PyObject *__pyx_n_KEY_TYPE_MASK;
static PyObject *__pyx_n_KEY_TYPE_SHIFT;
static PyObject *__pyx_n_KEY_TYPE_SYM;
static PyObject *__pyx_n_OperationError;
static PyObject *__pyx_n_TTY_DEFAULT;
static PyObject *__pyx_n___init__;
static PyObject *__pyx_n___str__;
static PyObject *__pyx_n_argument;
static PyObject *__pyx_n_attrAnd;
static PyObject *__pyx_n_attrOr;
static PyObject *__pyx_n_auth;
static PyObject *__pyx_n_brlerrno;
static PyObject *__pyx_n_center;
static PyObject *__pyx_n_charset;
static PyObject *__pyx_n_command;
static PyObject *__pyx_n_cursor;
static PyObject *__pyx_n_displayNumber;
static PyObject *__pyx_n_displaySize;
static PyObject *__pyx_n_encode;
static PyObject *__pyx_n_errfun;
static PyObject *__pyx_n_flags;
static PyObject *__pyx_n_gaierrno;
static PyObject *__pyx_n_host;
static PyObject *__pyx_n_libcerrno;
static PyObject *__pyx_n_rangeType_all;
static PyObject *__pyx_n_rangeType_code;
static PyObject *__pyx_n_rangeType_command;
static PyObject *__pyx_n_rangeType_key;
static PyObject *__pyx_n_rangeType_type;
static PyObject *__pyx_n_regionBegin;
static PyObject *__pyx_n_regionSize;
static PyObject *__pyx_n_settings;
static PyObject *__pyx_n_text;
static PyObject *__pyx_n_type;
static PyObject *__pyx_n_unicode;
static PyObject *__pyx_n_write;

static PyObject *__pyx_k9p;
static PyObject *__pyx_k14p;
static PyObject *__pyx_k25p;
static PyObject *__pyx_k256p;
static PyObject *__pyx_k257p;

static __Pyx_StringTabEntry __pyx_string_tab[] = {
  {&__pyx_n_CURSOR_LEAVE, 1, __pyx_k47, sizeof(__pyx_k47)},
  {&__pyx_n_CURSOR_OFF, 1, __pyx_k48, sizeof(__pyx_k48)},
  {&__pyx_n_ConnectionError, 1, __pyx_k16, sizeof(__pyx_k16)},
  {&__pyx_n_DISPLAY_DEFAULT, 1, __pyx_k46, sizeof(__pyx_k46)},
  {&__pyx_n_DOT1, 1, __pyx_k248, sizeof(__pyx_k248)},
  {&__pyx_n_DOT2, 1, __pyx_k249, sizeof(__pyx_k249)},
  {&__pyx_n_DOT3, 1, __pyx_k250, sizeof(__pyx_k250)},
  {&__pyx_n_DOT4, 1, __pyx_k251, sizeof(__pyx_k251)},
  {&__pyx_n_DOT5, 1, __pyx_k252, sizeof(__pyx_k252)},
  {&__pyx_n_DOT6, 1, __pyx_k253, sizeof(__pyx_k253)},
  {&__pyx_n_DOT7, 1, __pyx_k254, sizeof(__pyx_k254)},
  {&__pyx_n_DOT8, 1, __pyx_k255, sizeof(__pyx_k255)},
  {&__pyx_n_ERROR_AUTHENTICATION, 1, __pyx_k71, sizeof(__pyx_k71)},
  {&__pyx_n_ERROR_CONNREFUSED, 1, __pyx_k62, sizeof(__pyx_k62)},
  {&__pyx_n_ERROR_DEVICEBUSY, 1, __pyx_k57, sizeof(__pyx_k57)},
  {&__pyx_n_ERROR_DRIVERERROR, 1, __pyx_k70, sizeof(__pyx_k70)},
  {&__pyx_n_ERROR_EMPTYKEY, 1, __pyx_k69, sizeof(__pyx_k69)},
  {&__pyx_n_ERROR_EOF, 1, __pyx_k68, sizeof(__pyx_k68)},
  {&__pyx_n_ERROR_GAIERR, 1, __pyx_k64, sizeof(__pyx_k64)},
  {&__pyx_n_ERROR_ILLEGAL_INSTRUCTION, 1, __pyx_k59, sizeof(__pyx_k59)},
  {&__pyx_n_ERROR_INVALID_PACKET, 1, __pyx_k61, sizeof(__pyx_k61)},
  {&__pyx_n_ERROR_INVALID_PARAMETER, 1, __pyx_k60, sizeof(__pyx_k60)},
  {&__pyx_n_ERROR_LIBCERR, 1, __pyx_k65, sizeof(__pyx_k65)},
  {&__pyx_n_ERROR_NOMEM, 1, __pyx_k55, sizeof(__pyx_k55)},
  {&__pyx_n_ERROR_OPNOTSUPP, 1, __pyx_k63, sizeof(__pyx_k63)},
  {&__pyx_n_ERROR_PROTOCOL_VERSION, 1, __pyx_k67, sizeof(__pyx_k67)},
  {&__pyx_n_ERROR_SUCCESS, 1, __pyx_k54, sizeof(__pyx_k54)},
  {&__pyx_n_ERROR_TTYBUSY, 1, __pyx_k56, sizeof(__pyx_k56)},
  {&__pyx_n_ERROR_UNKNOWNTTY, 1, __pyx_k66, sizeof(__pyx_k66)},
  {&__pyx_n_ERROR_UNKNOWN_INSTRUCTION, 1, __pyx_k58, sizeof(__pyx_k58)},
  {&__pyx_n_KEY_CMD_ARG_MASK, 1, __pyx_k83, sizeof(__pyx_k83)},
  {&__pyx_n_KEY_CMD_ARG_SHIFT, 1, __pyx_k84, sizeof(__pyx_k84)},
  {&__pyx_n_KEY_CMD_ATTRBLINK, 1, __pyx_k179, sizeof(__pyx_k179)},
  {&__pyx_n_KEY_CMD_ATTRDN, 1, __pyx_k143, sizeof(__pyx_k143)},
  {&__pyx_n_KEY_CMD_ATTRUP, 1, __pyx_k142, sizeof(__pyx_k142)},
  {&__pyx_n_KEY_CMD_ATTRVIS, 1, __pyx_k178, sizeof(__pyx_k178)},
  {&__pyx_n_KEY_CMD_AUTOREPEAT, 1, __pyx_k182, sizeof(__pyx_k182)},
  {&__pyx_n_KEY_CMD_AUTOSPEAK, 1, __pyx_k183, sizeof(__pyx_k183)},
  {&__pyx_n_KEY_CMD_BACK, 1, __pyx_k165, sizeof(__pyx_k165)},
  {&__pyx_n_KEY_CMD_BLK_MASK, 1, __pyx_k81, sizeof(__pyx_k81)},
  {&__pyx_n_KEY_CMD_BLK_SHIFT, 1, __pyx_k82, sizeof(__pyx_k82)},
  {&__pyx_n_KEY_CMD_BOT, 1, __pyx_k145, sizeof(__pyx_k145)},
  {&__pyx_n_KEY_CMD_BOT_LEFT, 1, __pyx_k147, sizeof(__pyx_k147)},
  {&__pyx_n_KEY_CMD_CAPBLINK, 1, __pyx_k180, sizeof(__pyx_k180)},
  {&__pyx_n_KEY_CMD_CHRLT, 1, __pyx_k154, sizeof(__pyx_k154)},
  {&__pyx_n_KEY_CMD_CHRRT, 1, __pyx_k155, sizeof(__pyx_k155)},
  {&__pyx_n_KEY_CMD_CSRBLINK, 1, __pyx_k177, sizeof(__pyx_k177)},
  {&__pyx_n_KEY_CMD_CSRHIDE, 1, __pyx_k174, sizeof(__pyx_k174)},
  {&__pyx_n_KEY_CMD_CSRJMP_VERT, 1, __pyx_k207, sizeof(__pyx_k207)},
  {&__pyx_n_KEY_CMD_CSRSIZE, 1, __pyx_k176, sizeof(__pyx_k176)},
  {&__pyx_n_KEY_CMD_CSRTRK, 1, __pyx_k175, sizeof(__pyx_k175)},
  {&__pyx_n_KEY_CMD_CSRVIS, 1, __pyx_k173, sizeof(__pyx_k173)},
  {&__pyx_n_KEY_CMD_CUTAPPEND, 1, __pyx_k222, sizeof(__pyx_k222)},
  {&__pyx_n_KEY_CMD_CUTBEGIN, 1, __pyx_k221, sizeof(__pyx_k221)},
  {&__pyx_n_KEY_CMD_CUTLINE, 1, __pyx_k224, sizeof(__pyx_k224)},
  {&__pyx_n_KEY_CMD_CUTRECT, 1, __pyx_k223, sizeof(__pyx_k223)},
  {&__pyx_n_KEY_CMD_DESCCHAR, 1, __pyx_k228, sizeof(__pyx_k228)},
  {&__pyx_n_KEY_CMD_DISPMD, 1, __pyx_k168, sizeof(__pyx_k168)},
  {&__pyx_n_KEY_CMD_FREEZE, 1, __pyx_k167, sizeof(__pyx_k167)},
  {&__pyx_n_KEY_CMD_FWINLT, 1, __pyx_k158, sizeof(__pyx_k158)},
  {&__pyx_n_KEY_CMD_FWINLTSKIP, 1, __pyx_k160, sizeof(__pyx_k160)},
  {&__pyx_n_KEY_CMD_FWINRT, 1, __pyx_k159, sizeof(__pyx_k159)},
  {&__pyx_n_KEY_CMD_FWINRTSKIP, 1, __pyx_k161, sizeof(__pyx_k161)},
  {&__pyx_n_KEY_CMD_GOTOLINE, 1, __pyx_k232, sizeof(__pyx_k232)},
  {&__pyx_n_KEY_CMD_GOTOMARK, 1, __pyx_k231, sizeof(__pyx_k231)},
  {&__pyx_n_KEY_CMD_HELP, 1, __pyx_k184, sizeof(__pyx_k184)},
  {&__pyx_n_KEY_CMD_HOME, 1, __pyx_k164, sizeof(__pyx_k164)},
  {&__pyx_n_KEY_CMD_HWINLT, 1, __pyx_k156, sizeof(__pyx_k156)},
  {&__pyx_n_KEY_CMD_HWINRT, 1, __pyx_k157, sizeof(__pyx_k157)},
  {&__pyx_n_KEY_CMD_INFO, 1, __pyx_k185, sizeof(__pyx_k185)},
  {&__pyx_n_KEY_CMD_LEARN, 1, __pyx_k186, sizeof(__pyx_k186)},
  {&__pyx_n_KEY_CMD_LNBEG, 1, __pyx_k162, sizeof(__pyx_k162)},
  {&__pyx_n_KEY_CMD_LNDN, 1, __pyx_k137, sizeof(__pyx_k137)},
  {&__pyx_n_KEY_CMD_LNEND, 1, __pyx_k163, sizeof(__pyx_k163)},
  {&__pyx_n_KEY_CMD_LNUP, 1, __pyx_k136, sizeof(__pyx_k136)},
  {&__pyx_n_KEY_CMD_MENU_FIRST_ITEM, 1, __pyx_k190, sizeof(__pyx_k190)},
  {&__pyx_n_KEY_CMD_MENU_LAST_ITEM, 1, __pyx_k191, sizeof(__pyx_k191)},
  {&__pyx_n_KEY_CMD_MENU_NEXT_ITEM, 1, __pyx_k193, sizeof(__pyx_k193)},
  {&__pyx_n_KEY_CMD_MENU_NEXT_SETTING, 1, __pyx_k195, sizeof(__pyx_k195)},
  {&__pyx_n_KEY_CMD_MENU_PREV_ITEM, 1, __pyx_k192, sizeof(__pyx_k192)},
  {&__pyx_n_KEY_CMD_MENU_PREV_SETTING, 1, __pyx_k194, sizeof(__pyx_k194)},
  {&__pyx_n_KEY_CMD_MUTE, 1, __pyx_k196, sizeof(__pyx_k196)},
  {&__pyx_n_KEY_CMD_NOOP, 1, __pyx_k135, sizeof(__pyx_k135)},
  {&__pyx_n_KEY_CMD_NXDIFCHAR, 1, __pyx_k236, sizeof(__pyx_k236)},
  {&__pyx_n_KEY_CMD_NXDIFLN, 1, __pyx_k141, sizeof(__pyx_k141)},
  {&__pyx_n_KEY_CMD_NXINDENT, 1, __pyx_k227, sizeof(__pyx_k227)},
  {&__pyx_n_KEY_CMD_NXPGRPH, 1, __pyx_k149, sizeof(__pyx_k149)},
  {&__pyx_n_KEY_CMD_NXPROMPT, 1, __pyx_k151, sizeof(__pyx_k151)},
  {&__pyx_n_KEY_CMD_NXSEARCH, 1, __pyx_k153, sizeof(__pyx_k153)},
  {&__pyx_n_KEY_CMD_OFFLINE, 1, __pyx_k211, sizeof(__pyx_k211)},
  {&__pyx_n_KEY_CMD_PASSAT, 1, __pyx_k242, sizeof(__pyx_k242)},
  {&__pyx_n_KEY_CMD_PASSDOTS, 1, __pyx_k237, sizeof(__pyx_k237)},
  {&__pyx_n_KEY_CMD_PASSPS2, 1, __pyx_k244, sizeof(__pyx_k244)},
  {&__pyx_n_KEY_CMD_PASSXT, 1, __pyx_k243, sizeof(__pyx_k243)},
  {&__pyx_n_KEY_CMD_PASTE, 1, __pyx_k208, sizeof(__pyx_k208)},
  {&__pyx_n_KEY_CMD_PRDIFCHAR, 1, __pyx_k235, sizeof(__pyx_k235)},
  {&__pyx_n_KEY_CMD_PRDIFLN, 1, __pyx_k140, sizeof(__pyx_k140)},
  {&__pyx_n_KEY_CMD_PREFLOAD, 1, __pyx_k189, sizeof(__pyx_k189)},
  {&__pyx_n_KEY_CMD_PREFMENU, 1, __pyx_k187, sizeof(__pyx_k187)},
  {&__pyx_n_KEY_CMD_PREFSAVE, 1, __pyx_k188, sizeof(__pyx_k188)},
  {&__pyx_n_KEY_CMD_PRINDENT, 1, __pyx_k226, sizeof(__pyx_k226)},
  {&__pyx_n_KEY_CMD_PRPGRPH, 1, __pyx_k148, sizeof(__pyx_k148)},
  {&__pyx_n_KEY_CMD_PRPROMPT, 1, __pyx_k150, sizeof(__pyx_k150)},
  {&__pyx_n_KEY_CMD_PRSEARCH, 1, __pyx_k152, sizeof(__pyx_k152)},
  {&__pyx_n_KEY_CMD_RESTARTBRL, 1, __pyx_k209, sizeof(__pyx_k209)},
  {&__pyx_n_KEY_CMD_RESTARTSPEECH, 1, __pyx_k210, sizeof(__pyx_k210)},
  {&__pyx_n_KEY_CMD_RETURN, 1, __pyx_k166, sizeof(__pyx_k166)},
  {&__pyx_n_KEY_CMD_ROUTE, 1, __pyx_k220, sizeof(__pyx_k220)},
  {&__pyx_n_KEY_CMD_SAY_ABOVE, 1, __pyx_k199, sizeof(__pyx_k199)},
  {&__pyx_n_KEY_CMD_SAY_BELOW, 1, __pyx_k200, sizeof(__pyx_k200)},
  {&__pyx_n_KEY_CMD_SAY_FASTER, 1, __pyx_k202, sizeof(__pyx_k202)},
  {&__pyx_n_KEY_CMD_SAY_LINE, 1, __pyx_k198, sizeof(__pyx_k198)},
  {&__pyx_n_KEY_CMD_SAY_LOUDER, 1, __pyx_k204, sizeof(__pyx_k204)},
  {&__pyx_n_KEY_CMD_SAY_SLOWER, 1, __pyx_k201, sizeof(__pyx_k201)},
  {&__pyx_n_KEY_CMD_SAY_SOFTER, 1, __pyx_k203, sizeof(__pyx_k203)},
  {&__pyx_n_KEY_CMD_SETLEFT, 1, __pyx_k229, sizeof(__pyx_k229)},
  {&__pyx_n_KEY_CMD_SETMARK, 1, __pyx_k230, sizeof(__pyx_k230)},
  {&__pyx_n_KEY_CMD_SHUTDOWN, 1, __pyx_k212, sizeof(__pyx_k212)},
  {&__pyx_n_KEY_CMD_SIXDOTS, 1, __pyx_k169, sizeof(__pyx_k169)},
  {&__pyx_n_KEY_CMD_SKPBLNKWINS, 1, __pyx_k172, sizeof(__pyx_k172)},
  {&__pyx_n_KEY_CMD_SKPIDLNS, 1, __pyx_k171, sizeof(__pyx_k171)},
  {&__pyx_n_KEY_CMD_SLIDEWIN, 1, __pyx_k170, sizeof(__pyx_k170)},
  {&__pyx_n_KEY_CMD_SPKHOME, 1, __pyx_k197, sizeof(__pyx_k197)},
  {&__pyx_n_KEY_CMD_SWITCHVT, 1, __pyx_k225, sizeof(__pyx_k225)},
  {&__pyx_n_KEY_CMD_SWITCHVT_NEXT, 1, __pyx_k206, sizeof(__pyx_k206)},
  {&__pyx_n_KEY_CMD_SWITCHVT_PREV, 1, __pyx_k205, sizeof(__pyx_k205)},
  {&__pyx_n_KEY_CMD_TOP, 1, __pyx_k144, sizeof(__pyx_k144)},
  {&__pyx_n_KEY_CMD_TOP_LEFT, 1, __pyx_k146, sizeof(__pyx_k146)},
  {&__pyx_n_KEY_CMD_TUNES, 1, __pyx_k181, sizeof(__pyx_k181)},
  {&__pyx_n_KEY_CMD_WINDN, 1, __pyx_k139, sizeof(__pyx_k139)},
  {&__pyx_n_KEY_CMD_WINUP, 1, __pyx_k138, sizeof(__pyx_k138)},
  {&__pyx_n_KEY_CODE_MASK, 1, __pyx_k79, sizeof(__pyx_k79)},
  {&__pyx_n_KEY_CODE_SHIFT, 1, __pyx_k80, sizeof(__pyx_k80)},
  {&__pyx_n_KEY_FLAGS_MASK, 1, __pyx_k73, sizeof(__pyx_k73)},
  {&__pyx_n_KEY_FLAGS_SHIFT, 1, __pyx_k74, sizeof(__pyx_k74)},
  {&__pyx_n_KEY_FLG_CONTROL, 1, __pyx_k240, sizeof(__pyx_k240)},
  {&__pyx_n_KEY_FLG_KBD_EMUL0, 1, __pyx_k246, sizeof(__pyx_k246)},
  {&__pyx_n_KEY_FLG_KBD_EMUL1, 1, __pyx_k247, sizeof(__pyx_k247)},
  {&__pyx_n_KEY_FLG_KBD_RELEASE, 1, __pyx_k245, sizeof(__pyx_k245)},
  {&__pyx_n_KEY_FLG_LINE_SCALED, 1, __pyx_k233, sizeof(__pyx_k233)},
  {&__pyx_n_KEY_FLG_LINE_TOLEFT, 1, __pyx_k234, sizeof(__pyx_k234)},
  {&__pyx_n_KEY_FLG_META, 1, __pyx_k241, sizeof(__pyx_k241)},
  {&__pyx_n_KEY_FLG_REPEAT_DELAY, 1, __pyx_k218, sizeof(__pyx_k218)},
  {&__pyx_n_KEY_FLG_REPEAT_INITIAL, 1, __pyx_k217, sizeof(__pyx_k217)},
  {&__pyx_n_KEY_FLG_REPEAT_MASK, 1, __pyx_k219, sizeof(__pyx_k219)},
  {&__pyx_n_KEY_FLG_ROUTE, 1, __pyx_k216, sizeof(__pyx_k216)},
  {&__pyx_n_KEY_FLG_SHIFT, 1, __pyx_k238, sizeof(__pyx_k238)},
  {&__pyx_n_KEY_FLG_TOGGLE_MASK, 1, __pyx_k215, sizeof(__pyx_k215)},
  {&__pyx_n_KEY_FLG_TOGGLE_OFF, 1, __pyx_k214, sizeof(__pyx_k214)},
  {&__pyx_n_KEY_FLG_TOGGLE_ON, 1, __pyx_k213, sizeof(__pyx_k213)},
  {&__pyx_n_KEY_FLG_UPPER, 1, __pyx_k239, sizeof(__pyx_k239)},
  {&__pyx_n_KEY_MAX, 1, __pyx_k72, sizeof(__pyx_k72)},
  {&__pyx_n_KEY_SYM_BACKSPACE, 1, __pyx_k85, sizeof(__pyx_k85)},
  {&__pyx_n_KEY_SYM_DELETE, 1, __pyx_k133, sizeof(__pyx_k133)},
  {&__pyx_n_KEY_SYM_DOWN, 1, __pyx_k93, sizeof(__pyx_k93)},
  {&__pyx_n_KEY_SYM_END, 1, __pyx_k96, sizeof(__pyx_k96)},
  {&__pyx_n_KEY_SYM_ESCAPE, 1, __pyx_k88, sizeof(__pyx_k88)},
  {&__pyx_n_KEY_SYM_F1, 1, __pyx_k98, sizeof(__pyx_k98)},
  {&__pyx_n_KEY_SYM_F10, 1, __pyx_k107, sizeof(__pyx_k107)},
  {&__pyx_n_KEY_SYM_F11, 1, __pyx_k108, sizeof(__pyx_k108)},
  {&__pyx_n_KEY_SYM_F12, 1, __pyx_k109, sizeof(__pyx_k109)},
  {&__pyx_n_KEY_SYM_F13, 1, __pyx_k110, sizeof(__pyx_k110)},
  {&__pyx_n_KEY_SYM_F14, 1, __pyx_k111, sizeof(__pyx_k111)},
  {&__pyx_n_KEY_SYM_F15, 1, __pyx_k112, sizeof(__pyx_k112)},
  {&__pyx_n_KEY_SYM_F16, 1, __pyx_k113, sizeof(__pyx_k113)},
  {&__pyx_n_KEY_SYM_F17, 1, __pyx_k114, sizeof(__pyx_k114)},
  {&__pyx_n_KEY_SYM_F18, 1, __pyx_k115, sizeof(__pyx_k115)},
  {&__pyx_n_KEY_SYM_F19, 1, __pyx_k116, sizeof(__pyx_k116)},
  {&__pyx_n_KEY_SYM_F2, 1, __pyx_k99, sizeof(__pyx_k99)},
  {&__pyx_n_KEY_SYM_F20, 1, __pyx_k117, sizeof(__pyx_k117)},
  {&__pyx_n_KEY_SYM_F21, 1, __pyx_k118, sizeof(__pyx_k118)},
  {&__pyx_n_KEY_SYM_F22, 1, __pyx_k119, sizeof(__pyx_k119)},
  {&__pyx_n_KEY_SYM_F23, 1, __pyx_k120, sizeof(__pyx_k120)},
  {&__pyx_n_KEY_SYM_F24, 1, __pyx_k121, sizeof(__pyx_k121)},
  {&__pyx_n_KEY_SYM_F25, 1, __pyx_k122, sizeof(__pyx_k122)},
  {&__pyx_n_KEY_SYM_F26, 1, __pyx_k123, sizeof(__pyx_k123)},
  {&__pyx_n_KEY_SYM_F27, 1, __pyx_k124, sizeof(__pyx_k124)},
  {&__pyx_n_KEY_SYM_F28, 1, __pyx_k125, sizeof(__pyx_k125)},
  {&__pyx_n_KEY_SYM_F29, 1, __pyx_k126, sizeof(__pyx_k126)},
  {&__pyx_n_KEY_SYM_F3, 1, __pyx_k100, sizeof(__pyx_k100)},
  {&__pyx_n_KEY_SYM_F30, 1, __pyx_k127, sizeof(__pyx_k127)},
  {&__pyx_n_KEY_SYM_F31, 1, __pyx_k128, sizeof(__pyx_k128)},
  {&__pyx_n_KEY_SYM_F32, 1, __pyx_k129, sizeof(__pyx_k129)},
  {&__pyx_n_KEY_SYM_F33, 1, __pyx_k130, sizeof(__pyx_k130)},
  {&__pyx_n_KEY_SYM_F34, 1, __pyx_k131, sizeof(__pyx_k131)},
  {&__pyx_n_KEY_SYM_F35, 1, __pyx_k132, sizeof(__pyx_k132)},
  {&__pyx_n_KEY_SYM_F4, 1, __pyx_k101, sizeof(__pyx_k101)},
  {&__pyx_n_KEY_SYM_F5, 1, __pyx_k102, sizeof(__pyx_k102)},
  {&__pyx_n_KEY_SYM_F6, 1, __pyx_k103, sizeof(__pyx_k103)},
  {&__pyx_n_KEY_SYM_F7, 1, __pyx_k104, sizeof(__pyx_k104)},
  {&__pyx_n_KEY_SYM_F8, 1, __pyx_k105, sizeof(__pyx_k105)},
  {&__pyx_n_KEY_SYM_F9, 1, __pyx_k106, sizeof(__pyx_k106)},
  {&__pyx_n_KEY_SYM_HOME, 1, __pyx_k89, sizeof(__pyx_k89)},
  {&__pyx_n_KEY_SYM_INSERT, 1, __pyx_k97, sizeof(__pyx_k97)},
  {&__pyx_n_KEY_SYM_LEFT, 1, __pyx_k90, sizeof(__pyx_k90)},
  {&__pyx_n_KEY_SYM_LINEFEED, 1, __pyx_k87, sizeof(__pyx_k87)},
  {&__pyx_n_KEY_SYM_PAGE_DOWN, 1, __pyx_k95, sizeof(__pyx_k95)},
  {&__pyx_n_KEY_SYM_PAGE_UP, 1, __pyx_k94, sizeof(__pyx_k94)},
  {&__pyx_n_KEY_SYM_RIGHT, 1, __pyx_k92, sizeof(__pyx_k92)},
  {&__pyx_n_KEY_SYM_TAB, 1, __pyx_k86, sizeof(__pyx_k86)},
  {&__pyx_n_KEY_SYM_UNICODE, 1, __pyx_k134, sizeof(__pyx_k134)},
  {&__pyx_n_KEY_SYM_UP, 1, __pyx_k91, sizeof(__pyx_k91)},
  {&__pyx_n_KEY_TYPE_CMD, 1, __pyx_k77, sizeof(__pyx_k77)},
  {&__pyx_n_KEY_TYPE_MASK, 1, __pyx_k75, sizeof(__pyx_k75)},
  {&__pyx_n_KEY_TYPE_SHIFT, 1, __pyx_k76, sizeof(__pyx_k76)},
  {&__pyx_n_KEY_TYPE_SYM, 1, __pyx_k78, sizeof(__pyx_k78)},
  {&__pyx_n_OperationError, 1, __pyx_k5, sizeof(__pyx_k5)},
  {&__pyx_n_TTY_DEFAULT, 1, __pyx_k45, sizeof(__pyx_k45)},
  {&__pyx_n___init__, 1, __pyx_k6, sizeof(__pyx_k6)},
  {&__pyx_n___str__, 1, __pyx_k10, sizeof(__pyx_k10)},
  {&__pyx_n_argument, 1, __pyx_k30, sizeof(__pyx_k30)},
  {&__pyx_n_attrAnd, 1, __pyx_k21, sizeof(__pyx_k21)},
  {&__pyx_n_attrOr, 1, __pyx_k22, sizeof(__pyx_k22)},
  {&__pyx_n_auth, 1, __pyx_k8, sizeof(__pyx_k8)},
  {&__pyx_n_brlerrno, 1, __pyx_k1, sizeof(__pyx_k1)},
  {&__pyx_n_center, 1, __pyx_k26, sizeof(__pyx_k26)},
  {&__pyx_n_charset, 1, __pyx_k15, sizeof(__pyx_k15)},
  {&__pyx_n_command, 1, __pyx_k29, sizeof(__pyx_k29)},
  {&__pyx_n_cursor, 1, __pyx_k23, sizeof(__pyx_k23)},
  {&__pyx_n_displayNumber, 1, __pyx_k17, sizeof(__pyx_k17)},
  {&__pyx_n_displaySize, 1, __pyx_k24, sizeof(__pyx_k24)},
  {&__pyx_n_encode, 1, __pyx_k13, sizeof(__pyx_k13)},
  {&__pyx_n_errfun, 1, __pyx_k4, sizeof(__pyx_k4)},
  {&__pyx_n_flags, 1, __pyx_k31, sizeof(__pyx_k31)},
  {&__pyx_n_gaierrno, 1, __pyx_k3, sizeof(__pyx_k3)},
  {&__pyx_n_host, 1, __pyx_k7, sizeof(__pyx_k7)},
  {&__pyx_n_libcerrno, 1, __pyx_k2, sizeof(__pyx_k2)},
  {&__pyx_n_rangeType_all, 1, __pyx_k49, sizeof(__pyx_k49)},
  {&__pyx_n_rangeType_code, 1, __pyx_k53, sizeof(__pyx_k53)},
  {&__pyx_n_rangeType_command, 1, __pyx_k51, sizeof(__pyx_k51)},
  {&__pyx_n_rangeType_key, 1, __pyx_k52, sizeof(__pyx_k52)},
  {&__pyx_n_rangeType_type, 1, __pyx_k50, sizeof(__pyx_k50)},
  {&__pyx_n_regionBegin, 1, __pyx_k18, sizeof(__pyx_k18)},
  {&__pyx_n_regionSize, 1, __pyx_k19, sizeof(__pyx_k19)},
  {&__pyx_n_settings, 1, __pyx_k11, sizeof(__pyx_k11)},
  {&__pyx_n_text, 1, __pyx_k20, sizeof(__pyx_k20)},
  {&__pyx_n_type, 1, __pyx_k28, sizeof(__pyx_k28)},
  {&__pyx_n_unicode, 1, __pyx_k12, sizeof(__pyx_k12)},
  {&__pyx_n_write, 1, __pyx_k27, sizeof(__pyx_k27)},
  {&__pyx_k9p, 0, __pyx_k9, sizeof(__pyx_k9)},
  {&__pyx_k14p, 0, __pyx_k14, sizeof(__pyx_k14)},
  {&__pyx_k25p, 0, __pyx_k25, sizeof(__pyx_k25)},
  {&__pyx_k256p, 0, __pyx_k256, sizeof(__pyx_k256)},
  {&__pyx_k257p, 0, __pyx_k257, sizeof(__pyx_k257)},
  {0, 0, 0, 0}
};

static PyObject *__pyx_d1;
static PyObject *__pyx_d2;
static PyObject *__pyx_d3;
static PyObject *__pyx_d4;
static PyObject *__pyx_d5;
static PyObject *__pyx_d6;
static struct __pyx_obj_6brlapi_WriteStruct *__pyx_d7;
static PyObject *__pyx_d8;
static PyObject *__pyx_d9;
static PyObject *__pyx_d10;
static PyObject *__pyx_d11;
static PyObject *__pyx_d12;
static PyObject *__pyx_d13;
static PyObject *__pyx_d14;
static PyObject *__pyx_d15;
static PyObject *__pyx_d16;
static PyObject *__pyx_d17;


/* Implementation of brlapi */

static PyObject *__pyx_f_6brlapi_14OperationError___init__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyMethodDef __pyx_mdef_6brlapi_14OperationError___init__ = {"__init__", (PyCFunction)__pyx_f_6brlapi_14OperationError___init__, METH_VARARGS|METH_KEYWORDS, 0};
static PyObject *__pyx_f_6brlapi_14OperationError___init__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  static char *__pyx_argnames[] = {"self",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_self)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":73 */
  __pyx_1 = PyInt_FromLong(brlapi_error.brlerrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 73; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_brlerrno, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 73; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":74 */
  __pyx_1 = PyInt_FromLong(brlapi_error.libcerrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 74; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_libcerrno, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 74; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":75 */
  __pyx_1 = PyInt_FromLong(brlapi_error.gaierrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 75; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_gaierrno, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 75; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":76 */
  __pyx_1 = PyString_FromString(brlapi_error.errfun); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_errfun, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 76; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.OperationError.__init__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_14OperationError___str__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyMethodDef __pyx_mdef_6brlapi_14OperationError___str__ = {"__str__", (PyCFunction)__pyx_f_6brlapi_14OperationError___str__, METH_VARARGS|METH_KEYWORDS, 0};
static PyObject *__pyx_f_6brlapi_14OperationError___str__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  brlapi_error_t __pyx_v_error;
  PyObject *__pyx_v_str;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  char *__pyx_3;
  static char *__pyx_argnames[] = {"self",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_self)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_v_str = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":80 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_brlerrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 80; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 80; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_v_error.brlerrno = __pyx_2;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":81 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_libcerrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 81; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 81; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_v_error.libcerrno = __pyx_2;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":82 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_gaierrno); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 82; goto __pyx_L1;}
  __pyx_2 = PyInt_AsLong(__pyx_1); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 82; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_v_error.gaierrno = __pyx_2;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":83 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_errfun); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 83; goto __pyx_L1;}
  Py_DECREF(__pyx_v_str);
  __pyx_v_str = __pyx_1;
  __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":84 */
  __pyx_3 = PyString_AsString(__pyx_v_str); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 84; goto __pyx_L1;}
  __pyx_v_error.errfun = __pyx_3;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":85 */
  __pyx_1 = PyString_FromString(brlapi_strerror((&__pyx_v_error))); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 85; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.OperationError.__str__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_str);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_15ConnectionError___init__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyMethodDef __pyx_mdef_6brlapi_15ConnectionError___init__ = {"__init__", (PyCFunction)__pyx_f_6brlapi_15ConnectionError___init__, METH_VARARGS|METH_KEYWORDS, 0};
static PyObject *__pyx_f_6brlapi_15ConnectionError___init__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  PyObject *__pyx_v_host = 0;
  PyObject *__pyx_v_auth = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"self","host","auth",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OOO", __pyx_argnames, &__pyx_v_self, &__pyx_v_host, &__pyx_v_auth)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_host);
  Py_INCREF(__pyx_v_auth);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":91 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n___init__); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_self);
  __pyx_3 = PyObject_CallObject(__pyx_2, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 91; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":92 */
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_host, __pyx_v_host) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 92; goto __pyx_L1;}

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":93 */
  if (PyObject_SetAttr(__pyx_v_self, __pyx_n_auth, __pyx_v_auth) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 93; goto __pyx_L1;}

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.ConnectionError.__init__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_host);
  Py_DECREF(__pyx_v_auth);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_15ConnectionError___str__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static PyMethodDef __pyx_mdef_6brlapi_15ConnectionError___str__ = {"__str__", (PyCFunction)__pyx_f_6brlapi_15ConnectionError___str__, METH_VARARGS|METH_KEYWORDS, 0};
static PyObject *__pyx_f_6brlapi_15ConnectionError___str__(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"self",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_self)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_host); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_v_self, __pyx_n_auth); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  __pyx_4 = PyObject_GetAttr(__pyx_3, __pyx_n___str__); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  Py_INCREF(__pyx_v_self);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_self);
  __pyx_5 = PyObject_CallObject(__pyx_4, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_4 = PyTuple_New(3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_4, 0, __pyx_1);
  PyTuple_SET_ITEM(__pyx_4, 1, __pyx_2);
  PyTuple_SET_ITEM(__pyx_4, 2, __pyx_5);
  __pyx_1 = 0;
  __pyx_2 = 0;
  __pyx_5 = 0;
  __pyx_3 = PyNumber_Remainder(__pyx_k9p, __pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 96; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  __pyx_r = __pyx_3;
  __pyx_3 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("brlapi.ConnectionError.__str__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_15ConnectionError_host(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_15ConnectionError_host[] = "Host of BRLTTY server";
static PyMethodDef __pyx_mdef_6brlapi_15ConnectionError_host = {"host", (PyCFunction)__pyx_f_6brlapi_15ConnectionError_host, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_15ConnectionError_host};
static PyObject *__pyx_f_6brlapi_15ConnectionError_host(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"self",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_self)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_settings); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 100; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_host); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 100; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.ConnectionError.host");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_15ConnectionError_auth(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_15ConnectionError_auth[] = "Authentication method used";
static PyMethodDef __pyx_mdef_6brlapi_15ConnectionError_auth = {"auth", (PyCFunction)__pyx_f_6brlapi_15ConnectionError_auth, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_15ConnectionError_auth};
static PyObject *__pyx_f_6brlapi_15ConnectionError_auth(PyObject *__pyx_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_self = 0;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  static char *__pyx_argnames[] = {"self",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_self)) return 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_settings); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 104; goto __pyx_L1;}
  __pyx_2 = PyObject_GetAttr(__pyx_1, __pyx_n_auth); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 104; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_r = __pyx_2;
  __pyx_2 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.ConnectionError.auth");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return -1;
  Py_INCREF(__pyx_v_self);
  ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props = brlapi_writeArguments_initialized;

  __pyx_r = 0;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_13displayNumber___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_13displayNumber___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.displayNumber); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 119; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.WriteStruct.displayNumber.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_13displayNumber___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_13displayNumber___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);
  __pyx_1 = PyInt_AsLong(__pyx_v_val); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 121; goto __pyx_L1;}
  ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.displayNumber = __pyx_1;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.displayNumber.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_11regionBegin___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_11regionBegin___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyLong_FromUnsignedLong(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.regionBegin); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 126; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.WriteStruct.regionBegin.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_11regionBegin___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_11regionBegin___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  int __pyx_r;
  unsigned int __pyx_1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);
  __pyx_1 = PyInt_AsUnsignedLongMask(__pyx_v_val); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 128; goto __pyx_L1;}
  ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.regionBegin = __pyx_1;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.regionBegin.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_10regionSize___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_10regionSize___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyLong_FromUnsignedLong(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.regionSize); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 133; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.WriteStruct.regionSize.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_10regionSize___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_10regionSize___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  int __pyx_r;
  unsigned int __pyx_1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);
  __pyx_1 = PyInt_AsUnsignedLongMask(__pyx_v_val); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 135; goto __pyx_L1;}
  ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.regionSize = __pyx_1;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.regionSize.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_4text___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_4text___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (!(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text != 0));
  if (__pyx_1) {
    Py_INCREF(Py_None);
    __pyx_r = Py_None;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyString_FromString(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 143; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.WriteStruct.text.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_4text___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_4text___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  size_t __pyx_v_size;
  char *__pyx_v_c_val;
  int __pyx_r;
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  int __pyx_3;
  PyObject *__pyx_4 = 0;
  Py_ssize_t __pyx_5;
  char *__pyx_6;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":147 */
  __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  Py_INCREF(__pyx_v_val);
  PyTuple_SET_ITEM(__pyx_1, 0, __pyx_v_val);
  __pyx_2 = PyObject_CallObject(((PyObject *)(&PyType_Type)), __pyx_1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  __pyx_1 = __Pyx_GetName(__pyx_b, __pyx_n_unicode); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  if (PyObject_Cmp(__pyx_2, __pyx_1, &__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 147; goto __pyx_L1;}
  __pyx_3 = __pyx_3 == 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  if (__pyx_3) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":148 */
    __pyx_2 = PyObject_GetAttr(__pyx_v_val, __pyx_n_encode); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 148; goto __pyx_L1;}
    __pyx_1 = PyTuple_New(1); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 148; goto __pyx_L1;}
    Py_INCREF(__pyx_k14p);
    PyTuple_SET_ITEM(__pyx_1, 0, __pyx_k14p);
    __pyx_4 = PyObject_CallObject(__pyx_2, __pyx_1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 148; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    Py_DECREF(__pyx_v_val);
    __pyx_v_val = __pyx_4;
    __pyx_4 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":149 */
    if (PyObject_SetAttr(__pyx_v_self, __pyx_n_charset, __pyx_k14p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 149; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":150 */
  __pyx_3 = (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text != 0);
  if (__pyx_3) {
    free(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text);
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":152 */
  __pyx_3 = PyObject_IsTrue(__pyx_v_val); if (__pyx_3 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 152; goto __pyx_L1;}
  if (__pyx_3) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":153 */
    __pyx_5 = PyObject_Length(__pyx_v_val); if (__pyx_5 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 153; goto __pyx_L1;}
    __pyx_v_size = __pyx_5;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":154 */
    __pyx_6 = PyString_AsString(__pyx_v_val); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 154; goto __pyx_L1;}
    __pyx_v_c_val = __pyx_6;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":155 */
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text = ((char *)malloc((__pyx_v_size + 1)));

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":156 */
    memcpy(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text,__pyx_v_c_val,__pyx_v_size);

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":157 */
    (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text[__pyx_v_size]) = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":158 */
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.textSize = __pyx_v_size;
    goto __pyx_L4;
  }
  /*else*/ {
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.text = NULL;
  }
  __pyx_L4:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.WriteStruct.text.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_6cursor___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_6cursor___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.cursor); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 165; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.WriteStruct.cursor.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_6cursor___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_6cursor___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  int __pyx_r;
  int __pyx_1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);
  __pyx_1 = PyInt_AsLong(__pyx_v_val); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 167; goto __pyx_L1;}
  ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.cursor = __pyx_1;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.cursor.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_7charset___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_7charset___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (!(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset != 0));
  if (__pyx_1) {
    Py_INCREF(Py_None);
    __pyx_r = Py_None;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyString_FromString(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 175; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.WriteStruct.charset.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_7charset___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_7charset___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  size_t __pyx_v_size;
  char *__pyx_v_c_val;
  int __pyx_r;
  int __pyx_1;
  Py_ssize_t __pyx_2;
  char *__pyx_3;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":179 */
  __pyx_1 = (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset != 0);
  if (__pyx_1) {
    free(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset);
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":181 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_val); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 181; goto __pyx_L1;}
  if (__pyx_1) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":182 */
    __pyx_2 = PyObject_Length(__pyx_v_val); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 182; goto __pyx_L1;}
    __pyx_v_size = __pyx_2;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":183 */
    __pyx_3 = PyString_AsString(__pyx_v_val); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 183; goto __pyx_L1;}
    __pyx_v_c_val = __pyx_3;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":184 */
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset = ((char *)malloc((__pyx_v_size + 1)));

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":185 */
    memcpy(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset,__pyx_v_c_val,__pyx_v_size);

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":186 */
    (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset[__pyx_v_size]) = 0;
    goto __pyx_L3;
  }
  /*else*/ {
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.charset = NULL;
  }
  __pyx_L3:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.charset.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_7attrAnd___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_7attrAnd___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (!(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask != 0));
  if (__pyx_1) {
    Py_INCREF(Py_None);
    __pyx_r = Py_None;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyString_FromString(((char *)((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 196; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.WriteStruct.attrAnd.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_7attrAnd___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_7attrAnd___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  size_t __pyx_v_size;
  char *__pyx_v_c_val;
  int __pyx_r;
  int __pyx_1;
  Py_ssize_t __pyx_2;
  char *__pyx_3;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":200 */
  __pyx_1 = (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask != 0);
  if (__pyx_1) {
    free(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask);
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":202 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_val); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 202; goto __pyx_L1;}
  if (__pyx_1) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":203 */
    __pyx_2 = PyObject_Length(__pyx_v_val); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 203; goto __pyx_L1;}
    __pyx_v_size = __pyx_2;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":204 */
    __pyx_3 = PyString_AsString(__pyx_v_val); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 204; goto __pyx_L1;}
    __pyx_v_c_val = __pyx_3;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":205 */
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask = ((unsigned char *)malloc((__pyx_v_size + 1)));

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":206 */
    memcpy(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask,__pyx_v_c_val,__pyx_v_size);

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":207 */
    (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask[__pyx_v_size]) = 0;
    goto __pyx_L3;
  }
  /*else*/ {
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.andMask = NULL;
  }
  __pyx_L3:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.attrAnd.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_11WriteStruct_6attrOr___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_11WriteStruct_6attrOr___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = (!(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask != 0));
  if (__pyx_1) {
    Py_INCREF(Py_None);
    __pyx_r = Py_None;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyString_FromString(((char *)((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask)); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 217; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  __Pyx_AddTraceback("brlapi.WriteStruct.attrOr.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static int __pyx_f_6brlapi_11WriteStruct_6attrOr___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val); /*proto*/
static int __pyx_f_6brlapi_11WriteStruct_6attrOr___set__(PyObject *__pyx_v_self, PyObject *__pyx_v_val) {
  size_t __pyx_v_size;
  char *__pyx_v_c_val;
  int __pyx_r;
  int __pyx_1;
  Py_ssize_t __pyx_2;
  char *__pyx_3;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_val);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":221 */
  __pyx_1 = (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask != 0);
  if (__pyx_1) {
    free(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask);
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":223 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_val); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 223; goto __pyx_L1;}
  if (__pyx_1) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":224 */
    __pyx_2 = PyObject_Length(__pyx_v_val); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 224; goto __pyx_L1;}
    __pyx_v_size = __pyx_2;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":225 */
    __pyx_3 = PyString_AsString(__pyx_v_val); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 225; goto __pyx_L1;}
    __pyx_v_c_val = __pyx_3;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":226 */
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask = ((unsigned char *)malloc((__pyx_v_size + 1)));

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":227 */
    memcpy(((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask,__pyx_v_c_val,__pyx_v_size);

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":228 */
    (((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask[__pyx_v_size]) = 0;
    goto __pyx_L3;
  }
  /*else*/ {
    ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_v_self)->props.orMask = NULL;
  }
  __pyx_L3:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  __Pyx_AddTraceback("brlapi.WriteStruct.attrOr.__set__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_val);
  return __pyx_r;
}

static int __pyx_f_6brlapi_10Connection___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static int __pyx_f_6brlapi_10Connection___init__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_host = 0;
  PyObject *__pyx_v_auth = 0;
  brlapi_connectionSettings_t __pyx_v_client;
  int __pyx_r;
  int __pyx_1;
  char *__pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  PyObject *__pyx_6 = 0;
  static char *__pyx_argnames[] = {"host","auth",0};
  __pyx_v_host = __pyx_d1;
  __pyx_v_auth = __pyx_d2;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_host, &__pyx_v_auth)) return -1;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_host);
  Py_INCREF(__pyx_v_auth);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":250 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_auth); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 250; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyString_AsString(__pyx_v_auth); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 251; goto __pyx_L1;}
    __pyx_v_client.auth = __pyx_2;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_v_client.auth = NULL;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":255 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_host); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 255; goto __pyx_L1;}
  if (__pyx_1) {
    __pyx_2 = PyString_AsString(__pyx_v_host); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 256; goto __pyx_L1;}
    __pyx_v_client.host = __pyx_2;
    goto __pyx_L3;
  }
  /*else*/ {
    __pyx_v_client.host = NULL;
  }
  __pyx_L3:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":260 */
  ((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h = ((brlapi_handle_t *)malloc(brlapi_getHandleSize()));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":262 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":263 */
  ((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->fd = brlapi__openConnection(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,(&__pyx_v_client),(&((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->settings));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":264 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":265 */
  __pyx_1 = (((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->fd == (-1));
  if (__pyx_1) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":266 */
    free(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":267 */
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_ConnectionError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    __pyx_4 = PyString_FromString(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->settings.host); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    __pyx_5 = PyString_FromString(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->settings.auth); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    __pyx_6 = PyTuple_New(2); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_6, 0, __pyx_4);
    PyTuple_SET_ITEM(__pyx_6, 1, __pyx_5);
    __pyx_4 = 0;
    __pyx_5 = 0;
    __pyx_4 = PyObject_CallObject(__pyx_3, __pyx_6); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    Py_DECREF(__pyx_6); __pyx_6 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 267; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  __pyx_r = 0;
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_6);
  __Pyx_AddTraceback("brlapi.Connection.__init__");
  __pyx_r = -1;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_host);
  Py_DECREF(__pyx_v_auth);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection___del__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection___del__[] = "Close the BrlAPI conection";
static PyObject *__pyx_f_6brlapi_10Connection___del__(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_r;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":271 */
  brlapi__closeConnection(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":272 */
  free(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  __pyx_r = Py_None; Py_INCREF(Py_None);
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_4host___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_10Connection_4host___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyString_FromString(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->settings.host); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 277; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.Connection.host.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_4auth___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_10Connection_4auth___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyString_FromString(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->settings.auth); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 282; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.Connection.auth.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_14fileDescriptor___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_10Connection_14fileDescriptor___get__(PyObject *__pyx_v_self) {
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  Py_INCREF(__pyx_v_self);
  __pyx_1 = PyInt_FromLong(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->fd); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 287; goto __pyx_L1;}
  __pyx_r = __pyx_1;
  __pyx_1 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  __Pyx_AddTraceback("brlapi.Connection.fileDescriptor.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_11displaySize___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_10Connection_11displaySize___get__(PyObject *__pyx_v_self) {
  unsigned int __pyx_v_x;
  unsigned int __pyx_v_y;
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":296 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":297 */
  __pyx_v_retval = brlapi__getDisplaySize(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,(&__pyx_v_x),(&__pyx_v_y));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":298 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":299 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 300; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 300; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 300; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyLong_FromUnsignedLong(__pyx_v_x); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 302; goto __pyx_L1;}
    __pyx_3 = PyLong_FromUnsignedLong(__pyx_v_y); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 302; goto __pyx_L1;}
    __pyx_4 = PyTuple_New(2); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 302; goto __pyx_L1;}
    PyTuple_SET_ITEM(__pyx_4, 0, __pyx_2);
    PyTuple_SET_ITEM(__pyx_4, 1, __pyx_3);
    __pyx_2 = 0;
    __pyx_3 = 0;
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.displaySize.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_10driverName___get__(PyObject *__pyx_v_self); /*proto*/
static PyObject *__pyx_f_6brlapi_10Connection_10driverName___get__(PyObject *__pyx_v_self) {
  char __pyx_v_name[21];
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":310 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":311 */
  __pyx_v_retval = brlapi__getDriverName(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_name,(sizeof(__pyx_v_name)));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":312 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":313 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 314; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 314; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 314; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyString_FromString(__pyx_v_name); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 316; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.driverName.__get__");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_enterTtyMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_enterTtyMode[] = "Ask for some tty, with some key mechanism\n\n		See brlapi_enterTtyMode(3).\n\n		* tty : If tty >= 0, application takes control of the specified tty\n			If tty == TTY_DEFAULT, the library first tries to get the tty number from the WINDOWID environment variable (form xterm case), then the CONTROLVT variable, and at last reads /proc/self/stat (on linux)\n		* driver : Tells how the application wants readKey() to return key presses. None or \"\" means BrlTTY commands are required, whereas a driver name means that raw key codes returned by this driver are expected.";
static PyObject *__pyx_f_6brlapi_10Connection_enterTtyMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_tty = 0;
  PyObject *__pyx_v_driver = 0;
  int __pyx_v_retval;
  int __pyx_v_c_tty;
  char *__pyx_v_c_driver;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  char *__pyx_3;
  PyObject *__pyx_4 = 0;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"tty","driver",0};
  __pyx_v_tty = __pyx_d3;
  __pyx_v_driver = __pyx_d4;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_tty, &__pyx_v_driver)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_tty);
  Py_INCREF(__pyx_v_driver);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":329 */
  __pyx_1 = PyInt_AsLong(__pyx_v_tty); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 329; goto __pyx_L1;}
  __pyx_v_c_tty = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":330 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_driver); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 330; goto __pyx_L1;}
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {
    __pyx_v_c_driver = NULL;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = PyString_AsString(__pyx_v_driver); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 333; goto __pyx_L1;}
    __pyx_v_c_driver = __pyx_3;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":334 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":335 */
  __pyx_v_retval = brlapi__enterTtyMode(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_tty,__pyx_v_c_driver);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":336 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":337 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
    __pyx_5 = PyObject_CallObject(__pyx_4, 0); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_5, 0, 0);
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 338; goto __pyx_L1;}
    goto __pyx_L3;
  }
  /*else*/ {
    __pyx_4 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 340; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
  }
  __pyx_L3:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("brlapi.Connection.enterTtyMode");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_tty);
  Py_DECREF(__pyx_v_driver);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_enterTtyModeWithPath(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_enterTtyModeWithPath[] = "Ask for some tty, with some key mechanism\n\n		See brlapi_enterTtyModeWithPath(3).\n\n		* tty is an array of ttys representing the tty path to be got. Can be None.\n		* driver : has the same meaning as in enterTtyMode.\n		\n		Providing an empty array or None means to get the root.";
static PyObject *__pyx_f_6brlapi_10Connection_enterTtyModeWithPath(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_path = 0;
  PyObject *__pyx_v_driver = 0;
  int __pyx_v_retval;
  int *__pyx_v_c_ttys;
  int __pyx_v_c_nttys;
  char *__pyx_v_c_driver;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  Py_ssize_t __pyx_3;
  long __pyx_4;
  PyObject *__pyx_5 = 0;
  char *__pyx_6;
  PyObject *__pyx_7 = 0;
  static char *__pyx_argnames[] = {"path","driver",0};
  __pyx_v_path = __pyx_d5;
  __pyx_v_driver = __pyx_d6;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OO", __pyx_argnames, &__pyx_v_path, &__pyx_v_driver)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_path);
  Py_INCREF(__pyx_v_driver);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":355 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_path); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 355; goto __pyx_L1;}
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":356 */
    __pyx_v_c_ttys = NULL;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":357 */
    __pyx_v_c_nttys = 0;
    goto __pyx_L2;
  }
  /*else*/ {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":359 */
    __pyx_3 = PyObject_Length(__pyx_v_path); if (__pyx_3 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 359; goto __pyx_L1;}
    __pyx_v_c_nttys = __pyx_3;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":360 */
    __pyx_v_c_ttys = ((int *)malloc((__pyx_v_c_nttys * (sizeof(int)))));

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":361 */
    for (__pyx_4 = 0; __pyx_4 < __pyx_v_c_nttys; ++__pyx_4) {
      __pyx_5 = PyInt_FromLong(__pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 361; goto __pyx_L1;}
      Py_DECREF(__pyx_v_i);
      __pyx_v_i = __pyx_5;
      __pyx_5 = 0;
      __pyx_5 = PyObject_GetItem(__pyx_v_path, __pyx_v_i); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 362; goto __pyx_L1;}
      __pyx_1 = PyInt_AsLong(__pyx_5); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 362; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      __pyx_3 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 362; goto __pyx_L1;}
      (__pyx_v_c_ttys[__pyx_3]) = __pyx_1;
    }
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":363 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_driver); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 363; goto __pyx_L1;}
  __pyx_1 = (!__pyx_2);
  if (__pyx_1) {
    __pyx_v_c_driver = NULL;
    goto __pyx_L5;
  }
  /*else*/ {
    __pyx_6 = PyString_AsString(__pyx_v_driver); if (!__pyx_6) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 366; goto __pyx_L1;}
    __pyx_v_c_driver = __pyx_6;
  }
  __pyx_L5:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":367 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":368 */
  __pyx_v_retval = brlapi__enterTtyModeWithPath(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_ttys,__pyx_v_c_nttys,__pyx_v_c_driver);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":369 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":370 */
  __pyx_2 = (__pyx_v_c_ttys != 0);
  if (__pyx_2) {
    free(__pyx_v_c_ttys);
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":372 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_5 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
    __pyx_7 = PyObject_CallObject(__pyx_5, 0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    __Pyx_Raise(__pyx_7, 0, 0);
    Py_DECREF(__pyx_7); __pyx_7 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 373; goto __pyx_L1;}
    goto __pyx_L7;
  }
  /*else*/ {
    __pyx_5 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 375; goto __pyx_L1;}
    __pyx_r = __pyx_5;
    __pyx_5 = 0;
    goto __pyx_L0;
  }
  __pyx_L7:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_5);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("brlapi.Connection.enterTtyModeWithPath");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_path);
  Py_DECREF(__pyx_v_driver);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_leaveTtyMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_leaveTtyMode[] = "Stop controlling the tty\n		See brlapi_leaveTtyMode(3).";
static PyObject *__pyx_f_6brlapi_10Connection_leaveTtyMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":381 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":382 */
  __pyx_v_retval = brlapi__leaveTtyMode(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":383 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":384 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 385; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 385; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 385; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 387; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.leaveTtyMode");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_setFocus(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_setFocus[] = "Tell the current tty to brltty.\n		See brlapi_setFocus(3).\n		This is intended for focus tellers, such as brltty, xbrlapi, screen, ... enterTtyMode() must have been called before hand to tell where this focus applies in the tty tree.";
static PyObject *__pyx_f_6brlapi_10Connection_setFocus(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_tty = 0;
  int __pyx_v_retval;
  int __pyx_v_c_tty;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"tty",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_tty)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_tty);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":395 */
  __pyx_1 = PyInt_AsLong(__pyx_v_tty); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 395; goto __pyx_L1;}
  __pyx_v_c_tty = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":396 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":397 */
  __pyx_v_retval = brlapi__setFocus(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_tty);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":398 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":399 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 400; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 400; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 400; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 402; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.setFocus");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_tty);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_write(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_write[] = "Update a specific region of the braille display and apply and/or masks.\n		See brlapi_write(3).\n		* s : gives information necessary for the update";
static PyObject *__pyx_f_6brlapi_10Connection_write(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  struct __pyx_obj_6brlapi_WriteStruct *__pyx_v_writeArguments = 0;
  PyObject *__pyx_v_displayNumber = 0;
  PyObject *__pyx_v_regionBegin = 0;
  PyObject *__pyx_v_regionSize = 0;
  PyObject *__pyx_v_text = 0;
  PyObject *__pyx_v_andMask = 0;
  PyObject *__pyx_v_orMask = 0;
  PyObject *__pyx_v_cursor = 0;
  PyObject *__pyx_v_charset = 0;
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"writeArguments","displayNumber","regionBegin","regionSize","text","andMask","orMask","cursor","charset",0};
  __pyx_v_writeArguments = __pyx_d7;
  __pyx_v_displayNumber = __pyx_d8;
  __pyx_v_regionBegin = __pyx_d9;
  __pyx_v_regionSize = __pyx_d10;
  __pyx_v_text = __pyx_d11;
  __pyx_v_andMask = __pyx_d12;
  __pyx_v_orMask = __pyx_d13;
  __pyx_v_cursor = __pyx_d14;
  __pyx_v_charset = __pyx_d15;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|OOOOOOOOO", __pyx_argnames, &__pyx_v_writeArguments, &__pyx_v_displayNumber, &__pyx_v_regionBegin, &__pyx_v_regionSize, &__pyx_v_text, &__pyx_v_andMask, &__pyx_v_orMask, &__pyx_v_cursor, &__pyx_v_charset)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_writeArguments);
  Py_INCREF(__pyx_v_displayNumber);
  Py_INCREF(__pyx_v_regionBegin);
  Py_INCREF(__pyx_v_regionSize);
  Py_INCREF(__pyx_v_text);
  Py_INCREF(__pyx_v_andMask);
  Py_INCREF(__pyx_v_orMask);
  Py_INCREF(__pyx_v_cursor);
  Py_INCREF(__pyx_v_charset);
  if (!__Pyx_ArgTypeTest(((PyObject *)__pyx_v_writeArguments), __pyx_ptype_6brlapi_WriteStruct, 1, "writeArguments")) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 409; goto __pyx_L1;}

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":422 */
  __pyx_1 = PyObject_IsTrue(((PyObject *)__pyx_v_writeArguments)); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 422; goto __pyx_L1;}
  __pyx_2 = (!__pyx_1);
  if (__pyx_2) {
    __pyx_3 = PyObject_CallObject(((PyObject *)__pyx_ptype_6brlapi_WriteStruct), 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 423; goto __pyx_L1;}
    Py_DECREF(((PyObject *)__pyx_v_writeArguments));
    __pyx_v_writeArguments = ((struct __pyx_obj_6brlapi_WriteStruct *)__pyx_3);
    __pyx_3 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":424 */
  if (PyObject_Cmp(__pyx_v_displayNumber, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 424; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_displayNumber, __pyx_v_displayNumber) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 425; goto __pyx_L1;}
    goto __pyx_L3;
  }
  __pyx_L3:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":426 */
  if (PyObject_Cmp(__pyx_v_regionBegin, Py_None, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 426; goto __pyx_L1;}
  __pyx_2 = __pyx_2 != 0;
  if (__pyx_2) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_regionBegin, __pyx_v_regionBegin) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 427; goto __pyx_L1;}
    goto __pyx_L4;
  }
  __pyx_L4:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":428 */
  if (PyObject_Cmp(__pyx_v_regionSize, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 428; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_regionSize, __pyx_v_regionSize) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 429; goto __pyx_L1;}
    goto __pyx_L5;
  }
  __pyx_L5:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":430 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_text); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 430; goto __pyx_L1;}
  if (__pyx_2) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_text, __pyx_v_text) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 431; goto __pyx_L1;}
    goto __pyx_L6;
  }
  __pyx_L6:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":432 */
  __pyx_1 = PyObject_IsTrue(__pyx_v_andMask); if (__pyx_1 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 432; goto __pyx_L1;}
  if (__pyx_1) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_attrAnd, __pyx_v_andMask) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 433; goto __pyx_L1;}
    goto __pyx_L7;
  }
  __pyx_L7:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":434 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_orMask); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 434; goto __pyx_L1;}
  if (__pyx_2) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_attrOr, __pyx_v_orMask) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 435; goto __pyx_L1;}
    goto __pyx_L8;
  }
  __pyx_L8:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":436 */
  if (PyObject_Cmp(__pyx_v_cursor, Py_None, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 436; goto __pyx_L1;}
  __pyx_1 = __pyx_1 != 0;
  if (__pyx_1) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_cursor, __pyx_v_cursor) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 437; goto __pyx_L1;}
    goto __pyx_L9;
  }
  __pyx_L9:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":438 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_charset); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 438; goto __pyx_L1;}
  if (__pyx_2) {
    if (PyObject_SetAttr(((PyObject *)__pyx_v_writeArguments), __pyx_n_charset, __pyx_v_charset) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 439; goto __pyx_L1;}
    goto __pyx_L10;
  }
  __pyx_L10:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":440 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":441 */
  __pyx_v_retval = brlapi__write(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,(&__pyx_v_writeArguments->props));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":442 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":443 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 444; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 444; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 444; goto __pyx_L1;}
    goto __pyx_L11;
  }
  /*else*/ {
    __pyx_3 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 446; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L11:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.write");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_writeArguments);
  Py_DECREF(__pyx_v_displayNumber);
  Py_DECREF(__pyx_v_regionBegin);
  Py_DECREF(__pyx_v_regionSize);
  Py_DECREF(__pyx_v_text);
  Py_DECREF(__pyx_v_andMask);
  Py_DECREF(__pyx_v_orMask);
  Py_DECREF(__pyx_v_cursor);
  Py_DECREF(__pyx_v_charset);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_writeDots(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_writeDots[] = "Write the given dots array to the display.\n		See brlapi_writeDots(3).\n		* dots : points on an array of dot information, one per character. Its size must hence be the same as what displaysize provides.";
static PyObject *__pyx_f_6brlapi_10Connection_writeDots(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_dots = 0;
  int __pyx_v_retval;
  char *__pyx_v_c_dots;
  unsigned char *__pyx_v_c_udots;
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"dots",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_dots)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_dots);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":455 */
  __pyx_1 = PyString_AsString(__pyx_v_dots); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 455; goto __pyx_L1;}
  __pyx_v_c_dots = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":456 */
  __pyx_v_c_udots = ((unsigned char *)__pyx_v_c_dots);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":457 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":458 */
  __pyx_v_retval = brlapi__writeDots(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_udots);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":459 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":460 */
  __pyx_2 = (__pyx_v_retval == (-1));
  if (__pyx_2) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 461; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 461; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 461; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 463; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.writeDots");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_dots);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_writeText(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_writeText[] = "Write the given \0-terminated string to the braille display.\n		See brlapi_writeText(3).\n		If the string is too long, it is cut. If it\'s too short, spaces are appended. The current LC_CTYPE locale is considered, unless it is left as default \"C\", in which case the charset is assumed to be 8bits, and the same as the server\'s.\n\n		* cursor : gives the cursor position; if equal to CURSOR_OFF, no cursor is shown at all; if cursor == CURSOR_LEAVE, the cursor is left where it is\n		* text : points to the string to be displayed";
static PyObject *__pyx_f_6brlapi_10Connection_writeText(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_text = 0;
  PyObject *__pyx_v_cursor = 0;
  PyObject *__pyx_v_w;
  PyObject *__pyx_v_x;
  PyObject *__pyx_v_y;
  PyObject *__pyx_v_dispSize;
  PyObject *__pyx_r;
  PyObject *__pyx_1 = 0;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  Py_ssize_t __pyx_4;
  PyObject *__pyx_5 = 0;
  static char *__pyx_argnames[] = {"text","cursor",0};
  __pyx_v_cursor = __pyx_d16;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O|O", __pyx_argnames, &__pyx_v_text, &__pyx_v_cursor)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_text);
  Py_INCREF(__pyx_v_cursor);
  __pyx_v_w = Py_None; Py_INCREF(Py_None);
  __pyx_v_x = Py_None; Py_INCREF(Py_None);
  __pyx_v_y = Py_None; Py_INCREF(Py_None);
  __pyx_v_dispSize = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":472 */
  __pyx_1 = PyObject_CallObject(((PyObject *)__pyx_ptype_6brlapi_WriteStruct), 0); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 472; goto __pyx_L1;}
  Py_DECREF(__pyx_v_w);
  __pyx_v_w = __pyx_1;
  __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":473 */
  if (PyObject_SetAttr(__pyx_v_w, __pyx_n_cursor, __pyx_v_cursor) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 473; goto __pyx_L1;}

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":474 */
  __pyx_2 = PyObject_IsTrue(__pyx_v_text); if (__pyx_2 < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 474; goto __pyx_L1;}
  if (__pyx_2) {

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":475 */
    __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_displaySize); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
    __pyx_3 = PyObject_GetIter(__pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
    Py_DECREF(__pyx_1); __pyx_1 = 0;
    __pyx_1 = __Pyx_UnpackItem(__pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
    Py_DECREF(__pyx_v_x);
    __pyx_v_x = __pyx_1;
    __pyx_1 = 0;
    __pyx_1 = __Pyx_UnpackItem(__pyx_3); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
    Py_DECREF(__pyx_v_y);
    __pyx_v_y = __pyx_1;
    __pyx_1 = 0;
    if (__Pyx_EndUnpack(__pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 475; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":476 */
    __pyx_1 = PyNumber_Multiply(__pyx_v_x, __pyx_v_y); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 476; goto __pyx_L1;}
    Py_DECREF(__pyx_v_dispSize);
    __pyx_v_dispSize = __pyx_1;
    __pyx_1 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":477 */
    __pyx_4 = PyObject_Length(__pyx_v_text); if (__pyx_4 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 477; goto __pyx_L1;}
    __pyx_3 = PyInt_FromSsize_t(__pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 477; goto __pyx_L1;}
    if (PyObject_Cmp(__pyx_3, __pyx_v_dispSize, &__pyx_2) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 477; goto __pyx_L1;}
    __pyx_2 = __pyx_2 < 0;
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    if (__pyx_2) {
      __pyx_1 = PyObject_GetAttr(__pyx_k25p, __pyx_n_center); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      __pyx_4 = PyObject_Length(__pyx_v_text); if (__pyx_4 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      __pyx_3 = PyInt_FromSsize_t(__pyx_4); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      __pyx_5 = PyNumber_Subtract(__pyx_v_dispSize, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      PyTuple_SET_ITEM(__pyx_3, 0, __pyx_5);
      __pyx_5 = 0;
      __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      Py_DECREF(__pyx_1); __pyx_1 = 0;
      Py_DECREF(__pyx_3); __pyx_3 = 0;
      __pyx_1 = PyNumber_Add(__pyx_v_text, __pyx_5); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 478; goto __pyx_L1;}
      Py_DECREF(__pyx_5); __pyx_5 = 0;
      Py_DECREF(__pyx_v_text);
      __pyx_v_text = __pyx_1;
      __pyx_1 = 0;
      goto __pyx_L3;
    }
    __pyx_L3:;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":479 */
    __pyx_3 = PyInt_FromLong(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 479; goto __pyx_L1;}
    if (PyObject_SetAttr(__pyx_v_w, __pyx_n_regionBegin, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 479; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":480 */
    if (PyObject_SetAttr(__pyx_v_w, __pyx_n_regionSize, __pyx_v_dispSize) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 480; goto __pyx_L1;}

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":481 */
    __pyx_4 = PyInt_AsSsize_t(__pyx_v_dispSize); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 481; goto __pyx_L1;}
    __pyx_5 = PySequence_GetSlice(__pyx_v_text, 0, __pyx_4); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 481; goto __pyx_L1;}
    if (PyObject_SetAttr(__pyx_v_w, __pyx_n_text, __pyx_5) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 481; goto __pyx_L1;}
    Py_DECREF(__pyx_5); __pyx_5 = 0;
    goto __pyx_L2;
  }
  __pyx_L2:;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":482 */
  __pyx_1 = PyObject_GetAttr(__pyx_v_self, __pyx_n_write); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 482; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 482; goto __pyx_L1;}
  Py_INCREF(__pyx_v_w);
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_v_w);
  __pyx_5 = PyObject_CallObject(__pyx_1, __pyx_3); if (!__pyx_5) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 482; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  __pyx_r = __pyx_5;
  __pyx_5 = 0;
  goto __pyx_L0;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_5);
  __Pyx_AddTraceback("brlapi.Connection.writeText");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_w);
  Py_DECREF(__pyx_v_x);
  Py_DECREF(__pyx_v_y);
  Py_DECREF(__pyx_v_dispSize);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_text);
  Py_DECREF(__pyx_v_cursor);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_readKey(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_readKey[] = "Read a key from the braille keyboard.\n		See brlapi_readKey(3).\n\n		This function returns one key press\'s code.\n\n		If None or \"\" was given to enterTtyPath(), a brltty command is returned. It is hence pretty driver-independent, and should be used by default when no other option is possible.\n\n		By default, all commands but those which restart drivers and switch virtual are returned to the application and not to brltty. If the application doesn\'t want to see some command events, it should call either ignoreKeys() or ignoreKeyRanges().\n\n		If some driver name was given to enterTtyMode(), a raw keycode is returned, as specified by the terminal driver. It generally corresponds to the very code that the terminal tells to the driver. This should only be used by applications which are dedicated to a particular braille terminal. Hence, checking the terminal type thanks to a call to drivername before getting tty control is a pretty good idea.\n\n		By default, all the keypresses will be passed to the client, none will go through brltty, so the application will have to handle console switching itself for instance.";
static PyObject *__pyx_f_6brlapi_10Connection_readKey(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_wait = 0;
  brlapi_keyCode_t __pyx_v_code;
  int __pyx_v_retval;
  int __pyx_v_c_wait;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {"wait",0};
  __pyx_v_wait = __pyx_d17;
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "|O", __pyx_argnames, &__pyx_v_wait)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_wait);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":500 */
  __pyx_1 = PyInt_AsLong(__pyx_v_wait); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 500; goto __pyx_L1;}
  __pyx_v_c_wait = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":501 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":502 */
  __pyx_v_retval = brlapi__readKey(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_wait,(&__pyx_v_code));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":503 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":504 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 505; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 505; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 505; goto __pyx_L1;}
    goto __pyx_L2;
  }
  __pyx_1 = (__pyx_v_retval <= 0);
  if (__pyx_1) {
    if (PyObject_Cmp(__pyx_v_wait, Py_False, &__pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 506; goto __pyx_L1;}
    __pyx_1 = __pyx_1 == 0;
  }
  if (__pyx_1) {
    Py_INCREF(Py_None);
    __pyx_r = Py_None;
    goto __pyx_L0;
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyLong_FromUnsignedLongLong(__pyx_v_code); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 509; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.readKey");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_wait);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_expandKeyCode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_expandKeyCode[] = "Expand a keycode into its individual components.\n		See brlapi_expandKeyCode(3).";
static PyObject *__pyx_f_6brlapi_10Connection_expandKeyCode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_code = 0;
  brlapi_expandedKeyCode_t __pyx_v_ekc;
  int __pyx_v_retval;
  PyObject *__pyx_r;
  brlapi_keyCode_t __pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"code",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_code)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_code);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":516 */
  __pyx_1 = PyInt_AsUnsignedLongLongMask(__pyx_v_code); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 516; goto __pyx_L1;}
  __pyx_v_retval = brlapi_expandKeyCode(__pyx_1,(&__pyx_v_ekc));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":517 */
  __pyx_2 = (__pyx_v_retval == (-1));
  if (__pyx_2) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 518; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 518; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 518; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = PyDict_New(); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    __pyx_4 = PyLong_FromUnsignedLong(__pyx_v_ekc.type); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    if (PyDict_SetItem(__pyx_3, __pyx_n_type, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_4 = PyLong_FromUnsignedLong(__pyx_v_ekc.command); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    if (PyDict_SetItem(__pyx_3, __pyx_n_command, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_4 = PyLong_FromUnsignedLong(__pyx_v_ekc.argument); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    if (PyDict_SetItem(__pyx_3, __pyx_n_argument, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_4 = PyLong_FromUnsignedLong(__pyx_v_ekc.flags); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    if (PyDict_SetItem(__pyx_3, __pyx_n_flags, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 520; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.expandKeyCode");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_code);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_ignoreKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_ignoreKeys[] = "Ignore some key presses from the braille keyboard.\n		See brlapi_ignoreKeys(3).\n		\n		This function asks the server to give the provided keys to brltty, rather than returning them to the application via brlapi_readKey().\n		\n		The given codes should be brltty commands (nul or \"\" was given to brlapi_enterTtyMode())";
static PyObject *__pyx_f_6brlapi_10Connection_ignoreKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_key_type = 0;
  PyObject *__pyx_v_set = 0;
  int __pyx_v_retval;
  brlapi_rangeType_t __pyx_v_c_type;
  brlapi_keyCode_t *__pyx_v_c_set;
  unsigned int __pyx_v_c_n;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  brlapi_rangeType_t __pyx_1;
  Py_ssize_t __pyx_2;
  long __pyx_3;
  PyObject *__pyx_4 = 0;
  brlapi_keyCode_t __pyx_5;
  int __pyx_6;
  PyObject *__pyx_7 = 0;
  static char *__pyx_argnames[] = {"key_type","set",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_key_type, &__pyx_v_set)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_key_type);
  Py_INCREF(__pyx_v_set);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":533 */
  __pyx_1 = ((brlapi_rangeType_t)PyInt_AsLong(__pyx_v_key_type)); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 533; goto __pyx_L1;}
  __pyx_v_c_type = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":534 */
  __pyx_2 = PyObject_Length(__pyx_v_set); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 534; goto __pyx_L1;}
  __pyx_v_c_n = __pyx_2;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":535 */
  __pyx_v_c_set = ((brlapi_keyCode_t *)malloc((__pyx_v_c_n * (sizeof((__pyx_v_c_set[0]))))));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":536 */
  for (__pyx_3 = 0; __pyx_3 < __pyx_v_c_n; ++__pyx_3) {
    __pyx_4 = PyInt_FromLong(__pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 536; goto __pyx_L1;}
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_4;
    __pyx_4 = 0;
    __pyx_4 = PyObject_GetItem(__pyx_v_set, __pyx_v_i); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 537; goto __pyx_L1;}
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 537; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_2 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 537; goto __pyx_L1;}
    (__pyx_v_c_set[__pyx_2]) = __pyx_5;
  }

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":538 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":539 */
  __pyx_v_retval = brlapi__ignoreKeys(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_type,__pyx_v_c_set,__pyx_v_c_n);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":540 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":541 */
  free(__pyx_v_c_set);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":542 */
  __pyx_6 = (__pyx_v_retval == (-1));
  if (__pyx_6) {
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 543; goto __pyx_L1;}
    __pyx_7 = PyObject_CallObject(__pyx_4, 0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 543; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_7, 0, 0);
    Py_DECREF(__pyx_7); __pyx_7 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 543; goto __pyx_L1;}
    goto __pyx_L4;
  }
  /*else*/ {
    __pyx_4 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 545; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("brlapi.Connection.ignoreKeys");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_key_type);
  Py_DECREF(__pyx_v_set);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_acceptKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_acceptKeys[] = "Accept some key presses from the braille keyboard.\n		See brlapi_ignoreKeys(3).\n		\n		This function asks the server to give the provided keys to the application, and not give them to brltty.\n\n		The given codes should be brltty commands (nul or \"\" was given to brlapi_enterTtyMode())";
static PyObject *__pyx_f_6brlapi_10Connection_acceptKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_key_type = 0;
  PyObject *__pyx_v_set = 0;
  int __pyx_v_retval;
  brlapi_rangeType_t __pyx_v_c_type;
  brlapi_keyCode_t *__pyx_v_c_set;
  unsigned int __pyx_v_c_n;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  brlapi_rangeType_t __pyx_1;
  Py_ssize_t __pyx_2;
  long __pyx_3;
  PyObject *__pyx_4 = 0;
  brlapi_keyCode_t __pyx_5;
  int __pyx_6;
  PyObject *__pyx_7 = 0;
  static char *__pyx_argnames[] = {"key_type","set",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "OO", __pyx_argnames, &__pyx_v_key_type, &__pyx_v_set)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_key_type);
  Py_INCREF(__pyx_v_set);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":558 */
  __pyx_1 = ((brlapi_rangeType_t)PyInt_AsLong(__pyx_v_key_type)); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 558; goto __pyx_L1;}
  __pyx_v_c_type = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":559 */
  __pyx_2 = PyObject_Length(__pyx_v_set); if (__pyx_2 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 559; goto __pyx_L1;}
  __pyx_v_c_n = __pyx_2;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":560 */
  __pyx_v_c_set = ((brlapi_keyCode_t *)malloc((__pyx_v_c_n * (sizeof((__pyx_v_c_set[0]))))));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":561 */
  for (__pyx_3 = 0; __pyx_3 < __pyx_v_c_n; ++__pyx_3) {
    __pyx_4 = PyInt_FromLong(__pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 561; goto __pyx_L1;}
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_4;
    __pyx_4 = 0;
    __pyx_4 = PyObject_GetItem(__pyx_v_set, __pyx_v_i); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 562; goto __pyx_L1;}
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 562; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_2 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 562; goto __pyx_L1;}
    (__pyx_v_c_set[__pyx_2]) = __pyx_5;
  }

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":563 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":564 */
  __pyx_v_retval = brlapi__acceptKeys(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_type,__pyx_v_c_set,__pyx_v_c_n);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":565 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":566 */
  free(__pyx_v_c_set);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":567 */
  __pyx_6 = (__pyx_v_retval == (-1));
  if (__pyx_6) {
    __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 568; goto __pyx_L1;}
    __pyx_7 = PyObject_CallObject(__pyx_4, 0); if (!__pyx_7) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 568; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __Pyx_Raise(__pyx_7, 0, 0);
    Py_DECREF(__pyx_7); __pyx_7 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 568; goto __pyx_L1;}
    goto __pyx_L4;
  }
  /*else*/ {
    __pyx_4 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 570; goto __pyx_L1;}
    __pyx_r = __pyx_4;
    __pyx_4 = 0;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_4);
  Py_XDECREF(__pyx_7);
  __Pyx_AddTraceback("brlapi.Connection.acceptKeys");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_key_type);
  Py_DECREF(__pyx_v_set);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_ignoreAllKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_ignoreAllKeys[] = "Ignore all key presses from the braille keyboard.\n		See brlapi_ignoreAllKeys(3).\n		\n		This function asks the server to give all keys to brltty, rather than returning them to the application via brlapi_readKey().";
static PyObject *__pyx_f_6brlapi_10Connection_ignoreAllKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":578 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":579 */
  __pyx_v_retval = brlapi__ignoreAllKeys(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":580 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":581 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 582; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 582; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 582; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 584; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.ignoreAllKeys");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_acceptAllKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_acceptAllKeys[] = "Accept all key presses from the braille keyboard.\n		See brlapi_acceptAllKeys(3).\n		\n		This function asks the server to give all keys to the application, and not give them to brltty.\n\n		Warning: after calling this function, make sure to call brlapi_ignoreKeys() for ignoring important keys like BRL_CMD_SWITCHVT_PREV/NEXT and such.";
static PyObject *__pyx_f_6brlapi_10Connection_acceptAllKeys(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":594 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":595 */
  __pyx_v_retval = brlapi__acceptAllKeys(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":596 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":597 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 598; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 598; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 598; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 600; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.acceptAllKeys");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_ignoreKeyRanges(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_ignoreKeyRanges[] = "Ignore some key presses from the braille keyboard.\n		See brlapi_ignoreKeyRanges(3).\n		\n		This function asks the server to give the provided key ranges to brltty, rather than returning them to the application via brlapi_readKey().\n		\n		The given codes should be raw keycodes (i.e. some driver name was given to brlapi_enterTtyMode()) ";
static PyObject *__pyx_f_6brlapi_10Connection_ignoreKeyRanges(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_keys = 0;
  int __pyx_v_retval;
  brlapi_range_t *__pyx_v_c_keys;
  unsigned int __pyx_v_c_n;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  Py_ssize_t __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  brlapi_keyCode_t __pyx_5;
  int __pyx_6;
  static char *__pyx_argnames[] = {"keys",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_keys)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_keys);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":612 */
  __pyx_1 = PyObject_Length(__pyx_v_keys); if (__pyx_1 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 612; goto __pyx_L1;}
  __pyx_v_c_n = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":613 */
  __pyx_v_c_keys = ((brlapi_range_t *)malloc((__pyx_v_c_n * (sizeof((__pyx_v_c_keys[0]))))));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":614 */
  for (__pyx_2 = 0; __pyx_2 < __pyx_v_c_n; ++__pyx_2) {
    __pyx_3 = PyInt_FromLong(__pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 614; goto __pyx_L1;}
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_3;
    __pyx_3 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":615 */
    __pyx_3 = PyObject_GetItem(__pyx_v_keys, __pyx_v_i); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 615; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetItemInt(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 615; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 615; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 615; goto __pyx_L1;}
    (__pyx_v_c_keys[__pyx_1]).first = __pyx_5;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":616 */
    __pyx_3 = PyObject_GetItem(__pyx_v_keys, __pyx_v_i); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 616; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetItemInt(__pyx_3, 1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 616; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 616; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 616; goto __pyx_L1;}
    (__pyx_v_c_keys[__pyx_1]).last = __pyx_5;
  }

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":617 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":618 */
  __pyx_v_retval = brlapi__ignoreKeyRanges(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_keys,__pyx_v_c_n);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":619 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":620 */
  free(__pyx_v_c_keys);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":621 */
  __pyx_6 = (__pyx_v_retval == (-1));
  if (__pyx_6) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 622; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 622; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 622; goto __pyx_L1;}
    goto __pyx_L4;
  }
  /*else*/ {
    __pyx_3 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 624; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.ignoreKeyRanges");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_keys);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_acceptKeyRanges(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_acceptKeyRanges[] = "Accept some key presses from the braille keyboard.\n		See brlapi_acceptKeyRanges(3).\n		\n		This function asks the server to return the provided key ranges (inclusive) to the application, and not give them to brltty.\n		\n		The given codes should be raw keycodes (i.e. some driver name was given to brlapi_enterTtyMode()) ";
static PyObject *__pyx_f_6brlapi_10Connection_acceptKeyRanges(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_keys = 0;
  int __pyx_v_retval;
  brlapi_range_t *__pyx_v_c_keys;
  unsigned int __pyx_v_c_n;
  PyObject *__pyx_v_i;
  PyObject *__pyx_r;
  Py_ssize_t __pyx_1;
  long __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  brlapi_keyCode_t __pyx_5;
  int __pyx_6;
  static char *__pyx_argnames[] = {"keys",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_keys)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_keys);
  __pyx_v_i = Py_None; Py_INCREF(Py_None);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":636 */
  __pyx_1 = PyObject_Length(__pyx_v_keys); if (__pyx_1 == -1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 636; goto __pyx_L1;}
  __pyx_v_c_n = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":637 */
  __pyx_v_c_keys = ((brlapi_range_t *)malloc((__pyx_v_c_n * (sizeof((__pyx_v_c_keys[0]))))));

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":638 */
  for (__pyx_2 = 0; __pyx_2 < __pyx_v_c_n; ++__pyx_2) {
    __pyx_3 = PyInt_FromLong(__pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 638; goto __pyx_L1;}
    Py_DECREF(__pyx_v_i);
    __pyx_v_i = __pyx_3;
    __pyx_3 = 0;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":639 */
    __pyx_3 = PyObject_GetItem(__pyx_v_keys, __pyx_v_i); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 639; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetItemInt(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 639; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 639; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 639; goto __pyx_L1;}
    (__pyx_v_c_keys[__pyx_1]).first = __pyx_5;

    /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":640 */
    __pyx_3 = PyObject_GetItem(__pyx_v_keys, __pyx_v_i); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 640; goto __pyx_L1;}
    __pyx_4 = __Pyx_GetItemInt(__pyx_3, 1); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 640; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __pyx_5 = PyInt_AsUnsignedLongLongMask(__pyx_4); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 640; goto __pyx_L1;}
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    __pyx_1 = PyInt_AsSsize_t(__pyx_v_i); if (PyErr_Occurred()) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 640; goto __pyx_L1;}
    (__pyx_v_c_keys[__pyx_1]).last = __pyx_5;
  }

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":641 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":642 */
  __pyx_v_retval = brlapi__acceptKeyRanges(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_keys,__pyx_v_c_n);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":643 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":644 */
  free(__pyx_v_c_keys);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":645 */
  __pyx_6 = (__pyx_v_retval == (-1));
  if (__pyx_6) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 646; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 646; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 646; goto __pyx_L1;}
    goto __pyx_L4;
  }
  /*else*/ {
    __pyx_3 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 648; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L4:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.acceptKeyRanges");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_i);
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_keys);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_enterRawMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_enterRawMode[] = "Switch to Raw mode\n		See brlapi_enterRawMode(3).\n		\n		* driver : Specifies the name of the driver for which the raw communication will be established";
static PyObject *__pyx_f_6brlapi_10Connection_enterRawMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  PyObject *__pyx_v_driver = 0;
  int __pyx_v_retval;
  char *__pyx_v_c_driver;
  PyObject *__pyx_r;
  char *__pyx_1;
  int __pyx_2;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  static char *__pyx_argnames[] = {"driver",0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "O", __pyx_argnames, &__pyx_v_driver)) return 0;
  Py_INCREF(__pyx_v_self);
  Py_INCREF(__pyx_v_driver);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":657 */
  __pyx_1 = PyString_AsString(__pyx_v_driver); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 657; goto __pyx_L1;}
  __pyx_v_c_driver = __pyx_1;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":658 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":659 */
  __pyx_v_retval = brlapi__enterRawMode(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h,__pyx_v_c_driver);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":660 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":661 */
  __pyx_2 = (__pyx_v_retval == (-1));
  if (__pyx_2) {
    __pyx_3 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 662; goto __pyx_L1;}
    __pyx_4 = PyObject_CallObject(__pyx_3, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 662; goto __pyx_L1;}
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    __Pyx_Raise(__pyx_4, 0, 0);
    Py_DECREF(__pyx_4); __pyx_4 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 662; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_3 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 664; goto __pyx_L1;}
    __pyx_r = __pyx_3;
    __pyx_3 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi.Connection.enterRawMode");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  Py_DECREF(__pyx_v_driver);
  return __pyx_r;
}

static PyObject *__pyx_f_6brlapi_10Connection_leaveRawMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds); /*proto*/
static char __pyx_doc_6brlapi_10Connection_leaveRawMode[] = "leave Raw mode\n		See brlapi_leaveRawMode(3).";
static PyObject *__pyx_f_6brlapi_10Connection_leaveRawMode(PyObject *__pyx_v_self, PyObject *__pyx_args, PyObject *__pyx_kwds) {
  int __pyx_v_retval;
  PyObject *__pyx_r;
  int __pyx_1;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  static char *__pyx_argnames[] = {0};
  if (!PyArg_ParseTupleAndKeywords(__pyx_args, __pyx_kwds, "", __pyx_argnames)) return 0;
  Py_INCREF(__pyx_v_self);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":670 */
  Py_BEGIN_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":671 */
  __pyx_v_retval = brlapi__leaveRawMode(((struct __pyx_obj_6brlapi_Connection *)__pyx_v_self)->h);

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":672 */
  Py_END_ALLOW_THREADS;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":673 */
  __pyx_1 = (__pyx_v_retval == (-1));
  if (__pyx_1) {
    __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 674; goto __pyx_L1;}
    __pyx_3 = PyObject_CallObject(__pyx_2, 0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 674; goto __pyx_L1;}
    Py_DECREF(__pyx_2); __pyx_2 = 0;
    __Pyx_Raise(__pyx_3, 0, 0);
    Py_DECREF(__pyx_3); __pyx_3 = 0;
    {__pyx_filename = __pyx_f[0]; __pyx_lineno = 674; goto __pyx_L1;}
    goto __pyx_L2;
  }
  /*else*/ {
    __pyx_2 = PyInt_FromLong(__pyx_v_retval); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 676; goto __pyx_L1;}
    __pyx_r = __pyx_2;
    __pyx_2 = 0;
    goto __pyx_L0;
  }
  __pyx_L2:;

  __pyx_r = Py_None; Py_INCREF(Py_None);
  goto __pyx_L0;
  __pyx_L1:;
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  __Pyx_AddTraceback("brlapi.Connection.leaveRawMode");
  __pyx_r = 0;
  __pyx_L0:;
  Py_DECREF(__pyx_v_self);
  return __pyx_r;
}

static PyObject *__pyx_tp_new_6brlapi_WriteStruct(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_6brlapi_WriteStruct(PyObject *o) {
  (*o->ob_type->tp_free)(o);
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_displayNumber(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_13displayNumber___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_displayNumber(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_13displayNumber___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_regionBegin(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_11regionBegin___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_regionBegin(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_11regionBegin___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_regionSize(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_10regionSize___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_regionSize(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_10regionSize___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_text(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_4text___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_text(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_4text___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_cursor(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_6cursor___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_cursor(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_6cursor___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_charset(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_7charset___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_charset(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_7charset___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_attrAnd(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_7attrAnd___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_attrAnd(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_7attrAnd___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static PyObject *__pyx_getprop_6brlapi_11WriteStruct_attrOr(PyObject *o, void *x) {
  return __pyx_f_6brlapi_11WriteStruct_6attrOr___get__(o);
}

static int __pyx_setprop_6brlapi_11WriteStruct_attrOr(PyObject *o, PyObject *v, void *x) {
  if (v) {
    return __pyx_f_6brlapi_11WriteStruct_6attrOr___set__(o, v);
  }
  else {
    PyErr_SetString(PyExc_NotImplementedError, "__del__");
    return -1;
  }
}

static struct PyMethodDef __pyx_methods_6brlapi_WriteStruct[] = {
  {0, 0, 0, 0}
};

static struct PyGetSetDef __pyx_getsets_6brlapi_WriteStruct[] = {
  {"displayNumber", __pyx_getprop_6brlapi_11WriteStruct_displayNumber, __pyx_setprop_6brlapi_11WriteStruct_displayNumber, __pyx_k32, 0},
  {"regionBegin", __pyx_getprop_6brlapi_11WriteStruct_regionBegin, __pyx_setprop_6brlapi_11WriteStruct_regionBegin, __pyx_k33, 0},
  {"regionSize", __pyx_getprop_6brlapi_11WriteStruct_regionSize, __pyx_setprop_6brlapi_11WriteStruct_regionSize, __pyx_k34, 0},
  {"text", __pyx_getprop_6brlapi_11WriteStruct_text, __pyx_setprop_6brlapi_11WriteStruct_text, __pyx_k35, 0},
  {"cursor", __pyx_getprop_6brlapi_11WriteStruct_cursor, __pyx_setprop_6brlapi_11WriteStruct_cursor, __pyx_k36, 0},
  {"charset", __pyx_getprop_6brlapi_11WriteStruct_charset, __pyx_setprop_6brlapi_11WriteStruct_charset, __pyx_k37, 0},
  {"attrAnd", __pyx_getprop_6brlapi_11WriteStruct_attrAnd, __pyx_setprop_6brlapi_11WriteStruct_attrAnd, __pyx_k38, 0},
  {"attrOr", __pyx_getprop_6brlapi_11WriteStruct_attrOr, __pyx_setprop_6brlapi_11WriteStruct_attrOr, __pyx_k39, 0},
  {0, 0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_WriteStruct = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_WriteStruct = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_WriteStruct = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_WriteStruct = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_6brlapi_WriteStruct = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "brlapi.WriteStruct", /*tp_name*/
  sizeof(struct __pyx_obj_6brlapi_WriteStruct), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_6brlapi_WriteStruct, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_WriteStruct, /*tp_as_number*/
  &__pyx_tp_as_sequence_WriteStruct, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_WriteStruct, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_WriteStruct, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "Structure containing arguments to be given to Connection.write()\n	See brlapi_writeArguments_t(3).\n	\n	This is DEPRECATED. Use the named parameters of write() instead.", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_6brlapi_WriteStruct, /*tp_methods*/
  0, /*tp_members*/
  __pyx_getsets_6brlapi_WriteStruct, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_6brlapi_11WriteStruct___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_6brlapi_WriteStruct, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static PyObject *__pyx_tp_new_6brlapi_Connection(PyTypeObject *t, PyObject *a, PyObject *k) {
  PyObject *o = (*t->tp_alloc)(t, 0);
  if (!o) return 0;
  return o;
}

static void __pyx_tp_dealloc_6brlapi_Connection(PyObject *o) {
  (*o->ob_type->tp_free)(o);
}

static PyObject *__pyx_getprop_6brlapi_10Connection_host(PyObject *o, void *x) {
  return __pyx_f_6brlapi_10Connection_4host___get__(o);
}

static PyObject *__pyx_getprop_6brlapi_10Connection_auth(PyObject *o, void *x) {
  return __pyx_f_6brlapi_10Connection_4auth___get__(o);
}

static PyObject *__pyx_getprop_6brlapi_10Connection_fileDescriptor(PyObject *o, void *x) {
  return __pyx_f_6brlapi_10Connection_14fileDescriptor___get__(o);
}

static PyObject *__pyx_getprop_6brlapi_10Connection_displaySize(PyObject *o, void *x) {
  return __pyx_f_6brlapi_10Connection_11displaySize___get__(o);
}

static PyObject *__pyx_getprop_6brlapi_10Connection_driverName(PyObject *o, void *x) {
  return __pyx_f_6brlapi_10Connection_10driverName___get__(o);
}

static struct PyMethodDef __pyx_methods_6brlapi_Connection[] = {
  {"__del__", (PyCFunction)__pyx_f_6brlapi_10Connection___del__, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection___del__},
  {"enterTtyMode", (PyCFunction)__pyx_f_6brlapi_10Connection_enterTtyMode, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_enterTtyMode},
  {"enterTtyModeWithPath", (PyCFunction)__pyx_f_6brlapi_10Connection_enterTtyModeWithPath, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_enterTtyModeWithPath},
  {"leaveTtyMode", (PyCFunction)__pyx_f_6brlapi_10Connection_leaveTtyMode, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_leaveTtyMode},
  {"setFocus", (PyCFunction)__pyx_f_6brlapi_10Connection_setFocus, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_setFocus},
  {"write", (PyCFunction)__pyx_f_6brlapi_10Connection_write, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_write},
  {"writeDots", (PyCFunction)__pyx_f_6brlapi_10Connection_writeDots, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_writeDots},
  {"writeText", (PyCFunction)__pyx_f_6brlapi_10Connection_writeText, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_writeText},
  {"readKey", (PyCFunction)__pyx_f_6brlapi_10Connection_readKey, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_readKey},
  {"expandKeyCode", (PyCFunction)__pyx_f_6brlapi_10Connection_expandKeyCode, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_expandKeyCode},
  {"ignoreKeys", (PyCFunction)__pyx_f_6brlapi_10Connection_ignoreKeys, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_ignoreKeys},
  {"acceptKeys", (PyCFunction)__pyx_f_6brlapi_10Connection_acceptKeys, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_acceptKeys},
  {"ignoreAllKeys", (PyCFunction)__pyx_f_6brlapi_10Connection_ignoreAllKeys, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_ignoreAllKeys},
  {"acceptAllKeys", (PyCFunction)__pyx_f_6brlapi_10Connection_acceptAllKeys, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_acceptAllKeys},
  {"ignoreKeyRanges", (PyCFunction)__pyx_f_6brlapi_10Connection_ignoreKeyRanges, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_ignoreKeyRanges},
  {"acceptKeyRanges", (PyCFunction)__pyx_f_6brlapi_10Connection_acceptKeyRanges, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_acceptKeyRanges},
  {"enterRawMode", (PyCFunction)__pyx_f_6brlapi_10Connection_enterRawMode, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_enterRawMode},
  {"leaveRawMode", (PyCFunction)__pyx_f_6brlapi_10Connection_leaveRawMode, METH_VARARGS|METH_KEYWORDS, __pyx_doc_6brlapi_10Connection_leaveRawMode},
  {0, 0, 0, 0}
};

static struct PyGetSetDef __pyx_getsets_6brlapi_Connection[] = {
  {"host", __pyx_getprop_6brlapi_10Connection_host, 0, __pyx_k40, 0},
  {"auth", __pyx_getprop_6brlapi_10Connection_auth, 0, __pyx_k41, 0},
  {"fileDescriptor", __pyx_getprop_6brlapi_10Connection_fileDescriptor, 0, __pyx_k42, 0},
  {"displaySize", __pyx_getprop_6brlapi_10Connection_displaySize, 0, __pyx_k43, 0},
  {"driverName", __pyx_getprop_6brlapi_10Connection_driverName, 0, __pyx_k44, 0},
  {0, 0, 0, 0, 0}
};

static PyNumberMethods __pyx_tp_as_number_Connection = {
  0, /*nb_add*/
  0, /*nb_subtract*/
  0, /*nb_multiply*/
  0, /*nb_divide*/
  0, /*nb_remainder*/
  0, /*nb_divmod*/
  0, /*nb_power*/
  0, /*nb_negative*/
  0, /*nb_positive*/
  0, /*nb_absolute*/
  0, /*nb_nonzero*/
  0, /*nb_invert*/
  0, /*nb_lshift*/
  0, /*nb_rshift*/
  0, /*nb_and*/
  0, /*nb_xor*/
  0, /*nb_or*/
  0, /*nb_coerce*/
  0, /*nb_int*/
  0, /*nb_long*/
  0, /*nb_float*/
  0, /*nb_oct*/
  0, /*nb_hex*/
  0, /*nb_inplace_add*/
  0, /*nb_inplace_subtract*/
  0, /*nb_inplace_multiply*/
  0, /*nb_inplace_divide*/
  0, /*nb_inplace_remainder*/
  0, /*nb_inplace_power*/
  0, /*nb_inplace_lshift*/
  0, /*nb_inplace_rshift*/
  0, /*nb_inplace_and*/
  0, /*nb_inplace_xor*/
  0, /*nb_inplace_or*/
  0, /*nb_floor_divide*/
  0, /*nb_true_divide*/
  0, /*nb_inplace_floor_divide*/
  0, /*nb_inplace_true_divide*/
  #if Py_TPFLAGS_DEFAULT & Py_TPFLAGS_HAVE_INDEX
  0, /*nb_index*/
  #endif
};

static PySequenceMethods __pyx_tp_as_sequence_Connection = {
  0, /*sq_length*/
  0, /*sq_concat*/
  0, /*sq_repeat*/
  0, /*sq_item*/
  0, /*sq_slice*/
  0, /*sq_ass_item*/
  0, /*sq_ass_slice*/
  0, /*sq_contains*/
  0, /*sq_inplace_concat*/
  0, /*sq_inplace_repeat*/
};

static PyMappingMethods __pyx_tp_as_mapping_Connection = {
  0, /*mp_length*/
  0, /*mp_subscript*/
  0, /*mp_ass_subscript*/
};

static PyBufferProcs __pyx_tp_as_buffer_Connection = {
  0, /*bf_getreadbuffer*/
  0, /*bf_getwritebuffer*/
  0, /*bf_getsegcount*/
  0, /*bf_getcharbuffer*/
};

PyTypeObject __pyx_type_6brlapi_Connection = {
  PyObject_HEAD_INIT(0)
  0, /*ob_size*/
  "brlapi.Connection", /*tp_name*/
  sizeof(struct __pyx_obj_6brlapi_Connection), /*tp_basicsize*/
  0, /*tp_itemsize*/
  __pyx_tp_dealloc_6brlapi_Connection, /*tp_dealloc*/
  0, /*tp_print*/
  0, /*tp_getattr*/
  0, /*tp_setattr*/
  0, /*tp_compare*/
  0, /*tp_repr*/
  &__pyx_tp_as_number_Connection, /*tp_as_number*/
  &__pyx_tp_as_sequence_Connection, /*tp_as_sequence*/
  &__pyx_tp_as_mapping_Connection, /*tp_as_mapping*/
  0, /*tp_hash*/
  0, /*tp_call*/
  0, /*tp_str*/
  0, /*tp_getattro*/
  0, /*tp_setattro*/
  &__pyx_tp_as_buffer_Connection, /*tp_as_buffer*/
  Py_TPFLAGS_DEFAULT|Py_TPFLAGS_CHECKTYPES|Py_TPFLAGS_BASETYPE, /*tp_flags*/
  "Class which manages the bridge between your program and BrlAPI", /*tp_doc*/
  0, /*tp_traverse*/
  0, /*tp_clear*/
  0, /*tp_richcompare*/
  0, /*tp_weaklistoffset*/
  0, /*tp_iter*/
  0, /*tp_iternext*/
  __pyx_methods_6brlapi_Connection, /*tp_methods*/
  0, /*tp_members*/
  __pyx_getsets_6brlapi_Connection, /*tp_getset*/
  0, /*tp_base*/
  0, /*tp_dict*/
  0, /*tp_descr_get*/
  0, /*tp_descr_set*/
  0, /*tp_dictoffset*/
  __pyx_f_6brlapi_10Connection___init__, /*tp_init*/
  0, /*tp_alloc*/
  __pyx_tp_new_6brlapi_Connection, /*tp_new*/
  0, /*tp_free*/
  0, /*tp_is_gc*/
  0, /*tp_bases*/
  0, /*tp_mro*/
  0, /*tp_cache*/
  0, /*tp_subclasses*/
  0, /*tp_weaklist*/
};

static struct PyMethodDef __pyx_methods[] = {
  {0, 0, 0, 0}
};

static void __pyx_init_filenames(void); /*proto*/

PyMODINIT_FUNC initbrlapi(void); /*proto*/
PyMODINIT_FUNC initbrlapi(void) {
  PyObject *__pyx_1 = 0;
  PyObject *__pyx_2 = 0;
  PyObject *__pyx_3 = 0;
  PyObject *__pyx_4 = 0;
  __pyx_init_filenames();
  __pyx_m = Py_InitModule4("brlapi", __pyx_methods, __pyx_mdoc, 0, PYTHON_API_VERSION);
  if (!__pyx_m) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  Py_INCREF(__pyx_m);
  __pyx_b = PyImport_AddModule("__builtin__");
  if (!__pyx_b) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (PyObject_SetAttrString(__pyx_m, "__builtins__", __pyx_b) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (__Pyx_InitStrings(__pyx_string_tab) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 1; goto __pyx_L1;};
  if (PyType_Ready(&__pyx_type_6brlapi_WriteStruct) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 106; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "WriteStruct", (PyObject *)&__pyx_type_6brlapi_WriteStruct) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 106; goto __pyx_L1;}
  __pyx_ptype_6brlapi_WriteStruct = &__pyx_type_6brlapi_WriteStruct;
  if (PyType_Ready(&__pyx_type_6brlapi_Connection) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 232; goto __pyx_L1;}
  if (PyObject_SetAttrString(__pyx_m, "Connection", (PyObject *)&__pyx_type_6brlapi_Connection) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 232; goto __pyx_L1;}
  __pyx_ptype_6brlapi_Connection = &__pyx_type_6brlapi_Connection;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":1 */
  __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 1; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_TTY_DEFAULT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 1; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":2 */
  __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 2; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DISPLAY_DEFAULT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 2; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":3 */
  __pyx_1 = PyInt_FromLong((-1)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 3; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_CURSOR_LEAVE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 3; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":4 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 4; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_CURSOR_OFF, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 4; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":5 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 5; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_rangeType_all, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 5; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":6 */
  __pyx_1 = PyInt_FromLong(1); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 6; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_rangeType_type, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 6; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":7 */
  __pyx_1 = PyInt_FromLong(2); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 7; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_rangeType_command, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 7; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":8 */
  __pyx_1 = PyInt_FromLong(3); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 8; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_rangeType_key, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 8; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":9 */
  __pyx_1 = PyInt_FromLong(4); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 9; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_rangeType_code, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 9; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":10 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 10; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_SUCCESS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 10; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":11 */
  __pyx_1 = PyInt_FromLong(1); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 11; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_NOMEM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 11; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":12 */
  __pyx_1 = PyInt_FromLong(2); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 12; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_TTYBUSY, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 12; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":13 */
  __pyx_1 = PyInt_FromLong(3); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 13; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_DEVICEBUSY, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 13; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":14 */
  __pyx_1 = PyInt_FromLong(4); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 14; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_UNKNOWN_INSTRUCTION, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 14; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":15 */
  __pyx_1 = PyInt_FromLong(5); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 15; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_ILLEGAL_INSTRUCTION, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 15; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":16 */
  __pyx_1 = PyInt_FromLong(6); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 16; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_INVALID_PARAMETER, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 16; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":17 */
  __pyx_1 = PyInt_FromLong(7); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 17; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_INVALID_PACKET, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 17; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":18 */
  __pyx_1 = PyInt_FromLong(8); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 18; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_CONNREFUSED, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 18; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":19 */
  __pyx_1 = PyInt_FromLong(9); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 19; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_OPNOTSUPP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 19; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":20 */
  __pyx_1 = PyInt_FromLong(10); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 20; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_GAIERR, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 20; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":21 */
  __pyx_1 = PyInt_FromLong(11); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 21; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_LIBCERR, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 21; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":22 */
  __pyx_1 = PyInt_FromLong(12); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 22; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_UNKNOWNTTY, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 22; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":23 */
  __pyx_1 = PyInt_FromLong(13); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 23; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_PROTOCOL_VERSION, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 23; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":24 */
  __pyx_1 = PyInt_FromLong(14); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 24; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_EOF, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 24; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":25 */
  __pyx_1 = PyInt_FromLong(15); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 25; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_EMPTYKEY, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 25; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":26 */
  __pyx_1 = PyInt_FromLong(16); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 26; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_DRIVERERROR, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 26; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":27 */
  __pyx_1 = PyInt_FromLong(17); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 27; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ERROR_AUTHENTICATION, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 27; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":28 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_MAX); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 28; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_MAX, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 28; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":29 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_FLAGS_MASK); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 29; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLAGS_MASK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 29; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":30 */
  __pyx_1 = PyInt_FromLong(32); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 30; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLAGS_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 30; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":31 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_TYPE_MASK); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 31; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_TYPE_MASK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 31; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":32 */
  __pyx_1 = PyInt_FromLong(29); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 32; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_TYPE_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 32; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":33 */
  __pyx_1 = PyInt_FromLong(0x0000000020000000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 33; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_TYPE_CMD, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 33; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":34 */
  __pyx_1 = PyInt_FromLong(0x0000000000000000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 34; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_TYPE_SYM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 34; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":35 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_CODE_MASK); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 35; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CODE_MASK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 35; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":36 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 36; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CODE_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 36; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":37 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_CMD_BLK_MASK); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 37; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_BLK_MASK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 37; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":38 */
  __pyx_1 = PyInt_FromLong(16); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 38; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_BLK_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 38; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":39 */
  __pyx_1 = PyLong_FromUnsignedLongLong(BRLAPI_KEY_CMD_ARG_MASK); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 39; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ARG_MASK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 39; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":40 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 40; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ARG_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 40; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":41 */
  __pyx_1 = PyInt_FromLong(0x0000ff08); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 41; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_BACKSPACE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 41; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":42 */
  __pyx_1 = PyInt_FromLong(0x0000ff09); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 42; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_TAB, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 42; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":43 */
  __pyx_1 = PyInt_FromLong(0x0000ff0d); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 43; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_LINEFEED, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 43; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":44 */
  __pyx_1 = PyInt_FromLong(0x0000ff1b); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 44; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_ESCAPE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 44; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":45 */
  __pyx_1 = PyInt_FromLong(0x0000ff50); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 45; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_HOME, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 45; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":46 */
  __pyx_1 = PyInt_FromLong(0x0000ff51); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 46; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_LEFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 46; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":47 */
  __pyx_1 = PyInt_FromLong(0x0000ff52); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 47; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_UP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 47; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":48 */
  __pyx_1 = PyInt_FromLong(0x0000ff53); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 48; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_RIGHT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 48; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":49 */
  __pyx_1 = PyInt_FromLong(0x0000ff54); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 49; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_DOWN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 49; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":50 */
  __pyx_1 = PyInt_FromLong(0x0000ff55); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 50; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_PAGE_UP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 50; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":51 */
  __pyx_1 = PyInt_FromLong(0x0000ff56); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 51; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_PAGE_DOWN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 51; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":52 */
  __pyx_1 = PyInt_FromLong(0x0000ff57); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 52; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_END, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 52; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":53 */
  __pyx_1 = PyInt_FromLong(0x0000ff63); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 53; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_INSERT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 53; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":55 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 0)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 55; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F1, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 55; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":57 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 1)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 57; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F2, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 57; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":59 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 2)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 59; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F3, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 59; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":61 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 3)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 61; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F4, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 61; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":63 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 4)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 63; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F5, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 63; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":65 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 5)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 65; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F6, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 65; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":67 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 6)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 67; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F7, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 67; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":69 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 7)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 69; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F8, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 69; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":71 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 8)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 71; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F9, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 71; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":73 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 9)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 73; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F10, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 73; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":75 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 10)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 75; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F11, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 75; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":77 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 11)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 77; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F12, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 77; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":79 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 12)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 79; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F13, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 79; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":81 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 13)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 81; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F14, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 81; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":83 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 14)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 83; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F15, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 83; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":85 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 15)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 85; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F16, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 85; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":87 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 16)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 87; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F17, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 87; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":89 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 17)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 89; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F18, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 89; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":91 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 18)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 91; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F19, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 91; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":93 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 19)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 93; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F20, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 93; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":95 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 20)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 95; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F21, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":97 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 21)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 97; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F22, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 97; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":99 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 22)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 99; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F23, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 99; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":101 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 23)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 101; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F24, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 101; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":103 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 24)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 103; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F25, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 103; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":105 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 25)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 105; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F26, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 105; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":107 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 26)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 107; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F27, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 107; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":109 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 27)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 109; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F28, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 109; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":111 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 28)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 111; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F29, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 111; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":113 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 29)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 113; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F30, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 113; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":115 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 30)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 115; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F31, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 115; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":117 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 31)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 117; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F32, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 117; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":119 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 32)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 119; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F33, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 119; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":121 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 33)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 121; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F34, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 121; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":123 */
  __pyx_1 = PyInt_FromLong((0x0000ffbe + 34)); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 123; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_F35, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 123; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":124 */
  __pyx_1 = PyInt_FromLong(0x0000ffff); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 124; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_DELETE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 124; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":125 */
  __pyx_1 = PyInt_FromLong(0x01000000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 125; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_SYM_UNICODE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 125; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":127 */
  __pyx_1 = PyInt_FromLong(0); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 127; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NOOP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 127; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":129 */
  __pyx_1 = PyInt_FromLong(1); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 129; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_LNUP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 129; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":131 */
  __pyx_1 = PyInt_FromLong(2); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 131; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_LNDN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 131; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":133 */
  __pyx_1 = PyInt_FromLong(3); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 133; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_WINUP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 133; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":135 */
  __pyx_1 = PyInt_FromLong(4); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 135; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_WINDN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 135; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":137 */
  __pyx_1 = PyInt_FromLong(5); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 137; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRDIFLN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 137; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":139 */
  __pyx_1 = PyInt_FromLong(6); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 139; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXDIFLN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 139; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":141 */
  __pyx_1 = PyInt_FromLong(7); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 141; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ATTRUP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 141; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":143 */
  __pyx_1 = PyInt_FromLong(8); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 143; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ATTRDN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 143; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":145 */
  __pyx_1 = PyInt_FromLong(9); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 145; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_TOP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 145; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":147 */
  __pyx_1 = PyInt_FromLong(10); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 147; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_BOT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 147; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":149 */
  __pyx_1 = PyInt_FromLong(11); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 149; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_TOP_LEFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 149; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":151 */
  __pyx_1 = PyInt_FromLong(12); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 151; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_BOT_LEFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 151; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":153 */
  __pyx_1 = PyInt_FromLong(13); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 153; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRPGRPH, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 153; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":155 */
  __pyx_1 = PyInt_FromLong(14); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 155; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXPGRPH, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 155; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":157 */
  __pyx_1 = PyInt_FromLong(15); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 157; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRPROMPT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 157; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":159 */
  __pyx_1 = PyInt_FromLong(16); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 159; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXPROMPT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 159; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":161 */
  __pyx_1 = PyInt_FromLong(17); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 161; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRSEARCH, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 161; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":163 */
  __pyx_1 = PyInt_FromLong(18); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 163; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXSEARCH, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 163; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":165 */
  __pyx_1 = PyInt_FromLong(19); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 165; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CHRLT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 165; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":167 */
  __pyx_1 = PyInt_FromLong(20); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 167; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CHRRT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 167; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":169 */
  __pyx_1 = PyInt_FromLong(21); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 169; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_HWINLT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 169; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":171 */
  __pyx_1 = PyInt_FromLong(22); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 171; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_HWINRT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 171; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":173 */
  __pyx_1 = PyInt_FromLong(23); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 173; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_FWINLT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 173; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":175 */
  __pyx_1 = PyInt_FromLong(24); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 175; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_FWINRT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 175; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":177 */
  __pyx_1 = PyInt_FromLong(25); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 177; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_FWINLTSKIP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 177; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":179 */
  __pyx_1 = PyInt_FromLong(26); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 179; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_FWINRTSKIP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 179; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":181 */
  __pyx_1 = PyInt_FromLong(27); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 181; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_LNBEG, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 181; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":183 */
  __pyx_1 = PyInt_FromLong(28); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 183; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_LNEND, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 183; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":185 */
  __pyx_1 = PyInt_FromLong(29); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 185; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_HOME, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 185; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":187 */
  __pyx_1 = PyInt_FromLong(30); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 187; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_BACK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 187; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":189 */
  __pyx_1 = PyInt_FromLong(31); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 189; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_RETURN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 189; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":191 */
  __pyx_1 = PyInt_FromLong(32); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 191; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_FREEZE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 191; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":193 */
  __pyx_1 = PyInt_FromLong(33); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 193; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_DISPMD, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 193; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":195 */
  __pyx_1 = PyInt_FromLong(34); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 195; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SIXDOTS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 195; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":197 */
  __pyx_1 = PyInt_FromLong(35); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 197; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SLIDEWIN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 197; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":199 */
  __pyx_1 = PyInt_FromLong(36); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 199; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SKPIDLNS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 199; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":201 */
  __pyx_1 = PyInt_FromLong(37); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 201; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SKPBLNKWINS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 201; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":203 */
  __pyx_1 = PyInt_FromLong(38); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 203; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRVIS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 203; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":205 */
  __pyx_1 = PyInt_FromLong(39); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 205; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRHIDE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 205; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":207 */
  __pyx_1 = PyInt_FromLong(40); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 207; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRTRK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 207; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":209 */
  __pyx_1 = PyInt_FromLong(41); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 209; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRSIZE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 209; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":211 */
  __pyx_1 = PyInt_FromLong(42); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 211; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRBLINK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 211; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":213 */
  __pyx_1 = PyInt_FromLong(43); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 213; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ATTRVIS, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 213; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":215 */
  __pyx_1 = PyInt_FromLong(44); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 215; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ATTRBLINK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 215; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":217 */
  __pyx_1 = PyInt_FromLong(45); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 217; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CAPBLINK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 217; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":219 */
  __pyx_1 = PyInt_FromLong(46); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 219; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_TUNES, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 219; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":221 */
  __pyx_1 = PyInt_FromLong(47); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 221; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_AUTOREPEAT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 221; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":223 */
  __pyx_1 = PyInt_FromLong(48); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 223; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_AUTOSPEAK, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 223; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":225 */
  __pyx_1 = PyInt_FromLong(49); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 225; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_HELP, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 225; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":227 */
  __pyx_1 = PyInt_FromLong(50); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 227; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_INFO, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 227; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":229 */
  __pyx_1 = PyInt_FromLong(51); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 229; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_LEARN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 229; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":231 */
  __pyx_1 = PyInt_FromLong(52); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 231; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PREFMENU, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 231; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":233 */
  __pyx_1 = PyInt_FromLong(53); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 233; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PREFSAVE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 233; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":235 */
  __pyx_1 = PyInt_FromLong(54); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 235; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PREFLOAD, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 235; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":237 */
  __pyx_1 = PyInt_FromLong(55); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 237; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_FIRST_ITEM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 237; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":239 */
  __pyx_1 = PyInt_FromLong(56); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 239; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_LAST_ITEM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 239; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":241 */
  __pyx_1 = PyInt_FromLong(57); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 241; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_PREV_ITEM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 241; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":243 */
  __pyx_1 = PyInt_FromLong(58); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 243; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_NEXT_ITEM, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 243; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":245 */
  __pyx_1 = PyInt_FromLong(59); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 245; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_PREV_SETTING, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 245; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":247 */
  __pyx_1 = PyInt_FromLong(60); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 247; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MENU_NEXT_SETTING, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 247; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":249 */
  __pyx_1 = PyInt_FromLong(61); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 249; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_MUTE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 249; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":251 */
  __pyx_1 = PyInt_FromLong(62); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 251; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SPKHOME, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 251; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":253 */
  __pyx_1 = PyInt_FromLong(63); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 253; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_LINE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 253; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":255 */
  __pyx_1 = PyInt_FromLong(64); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 255; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_ABOVE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 255; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":257 */
  __pyx_1 = PyInt_FromLong(65); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 257; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_BELOW, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 257; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":259 */
  __pyx_1 = PyInt_FromLong(66); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 259; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_SLOWER, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 259; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":261 */
  __pyx_1 = PyInt_FromLong(67); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 261; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_FASTER, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 261; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":263 */
  __pyx_1 = PyInt_FromLong(68); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 263; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_SOFTER, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 263; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":265 */
  __pyx_1 = PyInt_FromLong(69); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 265; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SAY_LOUDER, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 265; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":267 */
  __pyx_1 = PyInt_FromLong(70); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 267; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SWITCHVT_PREV, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 267; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":269 */
  __pyx_1 = PyInt_FromLong(71); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 269; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SWITCHVT_NEXT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 269; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":271 */
  __pyx_1 = PyInt_FromLong(72); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 271; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CSRJMP_VERT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 271; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":273 */
  __pyx_1 = PyInt_FromLong(73); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 273; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PASTE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 273; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":275 */
  __pyx_1 = PyInt_FromLong(74); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 275; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_RESTARTBRL, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 275; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":277 */
  __pyx_1 = PyInt_FromLong(75); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 277; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_RESTARTSPEECH, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 277; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":279 */
  __pyx_1 = PyInt_FromLong(76); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 279; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_OFFLINE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 279; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":281 */
  __pyx_1 = PyInt_FromLong(77); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 281; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SHUTDOWN, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 281; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":283 */
  __pyx_1 = PyInt_FromLong(0x0100); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 283; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_TOGGLE_ON, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 283; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":285 */
  __pyx_1 = PyInt_FromLong(0x0200); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 285; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_TOGGLE_OFF, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 285; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":287 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_KEY_FLG_TOGGLE_ON); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 287; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_KEY_FLG_TOGGLE_OFF); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 287; goto __pyx_L1;}
  __pyx_3 = PyNumber_Or(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 287; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_TOGGLE_MASK, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 287; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":289 */
  __pyx_1 = PyInt_FromLong(0x0400); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 289; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_ROUTE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 289; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":291 */
  __pyx_2 = PyInt_FromLong(0x8000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 291; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_REPEAT_INITIAL, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 291; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":293 */
  __pyx_3 = PyInt_FromLong(0x4000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 293; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_REPEAT_DELAY, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 293; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":295 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_KEY_FLG_REPEAT_INITIAL); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 295; goto __pyx_L1;}
  __pyx_2 = __Pyx_GetName(__pyx_m, __pyx_n_KEY_FLG_REPEAT_DELAY); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 295; goto __pyx_L1;}
  __pyx_3 = PyNumber_Or(__pyx_1, __pyx_2); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 295; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_REPEAT_MASK, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 295; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":297 */
  __pyx_1 = PyInt_FromLong(0x010000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 297; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_ROUTE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 297; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":299 */
  __pyx_2 = PyInt_FromLong(0x020000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 299; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CUTBEGIN, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 299; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":301 */
  __pyx_3 = PyInt_FromLong(0x030000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 301; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CUTAPPEND, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 301; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":303 */
  __pyx_1 = PyInt_FromLong(0x040000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 303; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CUTRECT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 303; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":305 */
  __pyx_2 = PyInt_FromLong(0x050000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 305; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_CUTLINE, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 305; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":307 */
  __pyx_3 = PyInt_FromLong(0x060000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 307; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SWITCHVT, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 307; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":309 */
  __pyx_1 = PyInt_FromLong(0x070000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 309; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRINDENT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 309; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":311 */
  __pyx_2 = PyInt_FromLong(0x080000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 311; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXINDENT, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 311; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":313 */
  __pyx_3 = PyInt_FromLong(0x090000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 313; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_DESCCHAR, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 313; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":315 */
  __pyx_1 = PyInt_FromLong(0x0a0000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 315; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SETLEFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 315; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":317 */
  __pyx_2 = PyInt_FromLong(0x0b0000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 317; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_SETMARK, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 317; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":319 */
  __pyx_3 = PyInt_FromLong(0x0c0000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 319; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_GOTOMARK, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 319; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":321 */
  __pyx_1 = PyInt_FromLong(0x0d0000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 321; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_GOTOLINE, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 321; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":323 */
  __pyx_2 = PyInt_FromLong(0x0100); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 323; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_LINE_SCALED, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 323; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":325 */
  __pyx_3 = PyInt_FromLong(0x0200); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 325; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_LINE_TOLEFT, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 325; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":327 */
  __pyx_1 = PyInt_FromLong(0x0e0000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 327; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PRDIFCHAR, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 327; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":329 */
  __pyx_2 = PyInt_FromLong(0x0f0000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 329; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_NXDIFCHAR, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 329; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":331 */
  __pyx_3 = PyInt_FromLong(0x220000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 331; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PASSDOTS, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 331; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":333 */
  __pyx_1 = PyInt_FromLong(0x01); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 333; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_SHIFT, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 333; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":335 */
  __pyx_2 = PyInt_FromLong(0x02); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 335; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_UPPER, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 335; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":337 */
  __pyx_3 = PyInt_FromLong(0x04); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 337; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_CONTROL, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 337; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":339 */
  __pyx_1 = PyInt_FromLong(0x08); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 339; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_META, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 339; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":341 */
  __pyx_2 = PyInt_FromLong(0x230000); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 341; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PASSAT, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 341; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":343 */
  __pyx_3 = PyInt_FromLong(0x240000); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 343; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PASSXT, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 343; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":345 */
  __pyx_1 = PyInt_FromLong(0x250000); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 345; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_CMD_PASSPS2, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 345; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":347 */
  __pyx_2 = PyInt_FromLong(0x0100); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 347; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_KBD_RELEASE, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 347; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":349 */
  __pyx_3 = PyInt_FromLong(0x0200); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 349; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_KBD_EMUL0, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 349; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":351 */
  __pyx_1 = PyInt_FromLong(0x0400); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 351; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_KEY_FLG_KBD_EMUL1, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 351; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":353 */
  __pyx_2 = PyInt_FromLong(0001); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 353; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT1, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 353; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":355 */
  __pyx_3 = PyInt_FromLong(0002); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 355; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT2, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 355; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":357 */
  __pyx_1 = PyInt_FromLong(0004); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 357; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT3, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 357; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":359 */
  __pyx_2 = PyInt_FromLong(0010); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 359; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT4, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 359; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":361 */
  __pyx_3 = PyInt_FromLong(0020); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 361; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT5, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 361; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":363 */
  __pyx_1 = PyInt_FromLong(0040); if (!__pyx_1) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 363; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT6, __pyx_1) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 363; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":365 */
  __pyx_2 = PyInt_FromLong(0100); if (!__pyx_2) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 365; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT7, __pyx_2) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 365; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/constants.auto.pyx":367 */
  __pyx_3 = PyInt_FromLong(0200); if (!__pyx_3) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 367; goto __pyx_L1;}
  if (PyObject_SetAttr(__pyx_m, __pyx_n_DOT8, __pyx_3) < 0) {__pyx_filename = __pyx_f[1]; __pyx_lineno = 367; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":70 */
  __pyx_1 = PyDict_New(); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 70; goto __pyx_L1;}
  __pyx_2 = PyTuple_New(1); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 70; goto __pyx_L1;}
  Py_INCREF(PyExc_Exception);
  PyTuple_SET_ITEM(__pyx_2, 0, PyExc_Exception);
  if (PyDict_SetItemString(__pyx_1, "__doc__", __pyx_k256p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 70; goto __pyx_L1;}
  __pyx_3 = __Pyx_CreateClass(__pyx_2, __pyx_1, __pyx_n_OperationError, "brlapi"); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 70; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":72 */
  __pyx_2 = PyCFunction_New(&__pyx_mdef_6brlapi_14OperationError___init__, 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
  __pyx_4 = PyMethod_New(__pyx_2, 0, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (PyObject_SetAttr(__pyx_3, __pyx_n___init__, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 72; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":78 */
  __pyx_2 = PyCFunction_New(&__pyx_mdef_6brlapi_14OperationError___str__, 0); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 78; goto __pyx_L1;}
  __pyx_4 = PyMethod_New(__pyx_2, 0, __pyx_3); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 78; goto __pyx_L1;}
  Py_DECREF(__pyx_2); __pyx_2 = 0;
  if (PyObject_SetAttr(__pyx_3, __pyx_n___str__, __pyx_4) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 78; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_OperationError, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 70; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  Py_DECREF(__pyx_1); __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":87 */
  __pyx_2 = PyDict_New(); if (!__pyx_2) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_OperationError); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  __pyx_3 = PyTuple_New(1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  PyTuple_SET_ITEM(__pyx_3, 0, __pyx_4);
  __pyx_4 = 0;
  if (PyDict_SetItemString(__pyx_2, "__doc__", __pyx_k257p) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  __pyx_1 = __Pyx_CreateClass(__pyx_3, __pyx_2, __pyx_n_ConnectionError, "brlapi"); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":90 */
  __pyx_4 = PyCFunction_New(&__pyx_mdef_6brlapi_15ConnectionError___init__, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  __pyx_3 = PyMethod_New(__pyx_4, 0, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_1, __pyx_n___init__, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 90; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":95 */
  __pyx_4 = PyCFunction_New(&__pyx_mdef_6brlapi_15ConnectionError___str__, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  __pyx_3 = PyMethod_New(__pyx_4, 0, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_1, __pyx_n___str__, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 95; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":98 */
  __pyx_4 = PyCFunction_New(&__pyx_mdef_6brlapi_15ConnectionError_host, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 98; goto __pyx_L1;}
  __pyx_3 = PyMethod_New(__pyx_4, 0, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 98; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_1, __pyx_n_host, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 98; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":102 */
  __pyx_4 = PyCFunction_New(&__pyx_mdef_6brlapi_15ConnectionError_auth, 0); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 102; goto __pyx_L1;}
  __pyx_3 = PyMethod_New(__pyx_4, 0, __pyx_1); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 102; goto __pyx_L1;}
  Py_DECREF(__pyx_4); __pyx_4 = 0;
  if (PyObject_SetAttr(__pyx_1, __pyx_n_auth, __pyx_3) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 102; goto __pyx_L1;}
  Py_DECREF(__pyx_3); __pyx_3 = 0;
  if (PyObject_SetAttr(__pyx_m, __pyx_n_ConnectionError, __pyx_1) < 0) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 87; goto __pyx_L1;}
  Py_DECREF(__pyx_1); __pyx_1 = 0;
  Py_DECREF(__pyx_2); __pyx_2 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":239 */
  Py_INCREF(Py_None);
  __pyx_d1 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d2 = Py_None;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":318 */
  __pyx_4 = __Pyx_GetName(__pyx_m, __pyx_n_TTY_DEFAULT); if (!__pyx_4) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 318; goto __pyx_L1;}
  __pyx_d3 = __pyx_4;
  __pyx_4 = 0;
  Py_INCREF(Py_None);
  __pyx_d4 = Py_None;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":342 */
  __pyx_3 = PyList_New(0); if (!__pyx_3) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 342; goto __pyx_L1;}
  __pyx_d5 = __pyx_3;
  __pyx_3 = 0;
  Py_INCREF(Py_None);
  __pyx_d6 = Py_None;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":409 */
  Py_INCREF(Py_None);
  __pyx_d7 = ((struct __pyx_obj_6brlapi_WriteStruct *)Py_None);
  Py_INCREF(Py_None);
  __pyx_d8 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d9 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d10 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d11 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d12 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d13 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d14 = Py_None;
  Py_INCREF(Py_None);
  __pyx_d15 = Py_None;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":465 */
  __pyx_1 = __Pyx_GetName(__pyx_m, __pyx_n_CURSOR_OFF); if (!__pyx_1) {__pyx_filename = __pyx_f[0]; __pyx_lineno = 465; goto __pyx_L1;}
  __pyx_d16 = __pyx_1;
  __pyx_1 = 0;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":484 */
  Py_INCREF(Py_True);
  __pyx_d17 = Py_True;

  /* "/builddir/build/BUILD/brltty-3.10/Bindings/Python/brlapi.pyx":666 */
  return;
  __pyx_L1:;
  Py_XDECREF(__pyx_1);
  Py_XDECREF(__pyx_2);
  Py_XDECREF(__pyx_3);
  Py_XDECREF(__pyx_4);
  __Pyx_AddTraceback("brlapi");
}

static char *__pyx_filenames[] = {
  "brlapi.pyx",
  "constants.auto.pyx",
};

/* Runtime support code */

static void __pyx_init_filenames(void) {
  __pyx_f = __pyx_filenames;
}

static PyObject *__Pyx_GetName(PyObject *dict, PyObject *name) {
    PyObject *result;
    result = PyObject_GetAttr(dict, name);
    if (!result)
        PyErr_SetObject(PyExc_NameError, name);
    return result;
}

static void __Pyx_Raise(PyObject *type, PyObject *value, PyObject *tb) {
    Py_XINCREF(type);
    Py_XINCREF(value);
    Py_XINCREF(tb);
    /* First, check the traceback argument, replacing None with NULL. */
    if (tb == Py_None) {
        Py_DECREF(tb);
        tb = 0;
    }
    else if (tb != NULL && !PyTraceBack_Check(tb)) {
        PyErr_SetString(PyExc_TypeError,
            "raise: arg 3 must be a traceback or None");
        goto raise_error;
    }
    /* Next, replace a missing value with None */
    if (value == NULL) {
        value = Py_None;
        Py_INCREF(value);
    }
    #if PY_VERSION_HEX < 0x02050000
    if (!PyClass_Check(type))
    #else
    if (!PyType_Check(type))
    #endif
    {
        /* Raising an instance.  The value should be a dummy. */
        if (value != Py_None) {
            PyErr_SetString(PyExc_TypeError,
                "instance exception may not have a separate value");
            goto raise_error;
        }
        /* Normalize to raise <class>, <instance> */
        Py_DECREF(value);
        value = type;
        #if PY_VERSION_HEX < 0x02050000
            if (PyInstance_Check(type)) {
                type = (PyObject*) ((PyInstanceObject*)type)->in_class;
                Py_INCREF(type);
            }
            else {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception must be an old-style class or instance");
                goto raise_error;
            }
        #else
            type = (PyObject*) type->ob_type;
            Py_INCREF(type);
            if (!PyType_IsSubtype((PyTypeObject *)type, (PyTypeObject *)PyExc_BaseException)) {
                PyErr_SetString(PyExc_TypeError,
                    "raise: exception class must be a subclass of BaseException");
                goto raise_error;
            }
        #endif
    }
    PyErr_Restore(type, value, tb);
    return;
raise_error:
    Py_XDECREF(value);
    Py_XDECREF(type);
    Py_XDECREF(tb);
    return;
}

static int __Pyx_ArgTypeTest(PyObject *obj, PyTypeObject *type, int none_allowed, char *name) {
    if (!type) {
        PyErr_Format(PyExc_SystemError, "Missing type object");
        return 0;
    }
    if ((none_allowed && obj == Py_None) || PyObject_TypeCheck(obj, type))
        return 1;
    PyErr_Format(PyExc_TypeError,
        "Argument '%s' has incorrect type (expected %s, got %s)",
        name, type->tp_name, obj->ob_type->tp_name);
    return 0;
}

static void __Pyx_UnpackError(void) {
    PyErr_SetString(PyExc_ValueError, "unpack sequence of wrong size");
}

static PyObject *__Pyx_UnpackItem(PyObject *iter) {
    PyObject *item;
    if (!(item = PyIter_Next(iter))) {
        if (!PyErr_Occurred())
            __Pyx_UnpackError();
    }
    return item;
}

static int __Pyx_EndUnpack(PyObject *iter) {
    PyObject *item;
    if ((item = PyIter_Next(iter))) {
        Py_DECREF(item);
        __Pyx_UnpackError();
        return -1;
    }
    else if (!PyErr_Occurred())
        return 0;
    else
        return -1;
}

static PyObject *__Pyx_GetItemInt(PyObject *o, Py_ssize_t i) {
    PyTypeObject *t = o->ob_type;
    PyObject *r;
    if (t->tp_as_sequence && t->tp_as_sequence->sq_item)
        r = PySequence_GetItem(o, i);
    else {
        PyObject *j = PyInt_FromLong(i);
        if (!j)
            return 0;
        r = PyObject_GetItem(o, j);
        Py_DECREF(j);
    }
    return r;
}

static int __Pyx_InitStrings(__Pyx_StringTabEntry *t) {
    while (t->p) {
        *t->p = PyString_FromStringAndSize(t->s, t->n - 1);
        if (!*t->p)
            return -1;
        if (t->i)
            PyString_InternInPlace(t->p);
        ++t;
    }
    return 0;
}

static PyObject *__Pyx_CreateClass(
    PyObject *bases, PyObject *dict, PyObject *name, char *modname)
{
    PyObject *py_modname;
    PyObject *result = 0;
    
    py_modname = PyString_FromString(modname);
    if (!py_modname)
        goto bad;
    if (PyDict_SetItemString(dict, "__module__", py_modname) < 0)
        goto bad;
    result = PyClass_New(bases, dict, name);
bad:
    Py_XDECREF(py_modname);
    return result;
}

#include "compile.h"
#include "frameobject.h"
#include "traceback.h"

static void __Pyx_AddTraceback(char *funcname) {
    PyObject *py_srcfile = 0;
    PyObject *py_funcname = 0;
    PyObject *py_globals = 0;
    PyObject *empty_tuple = 0;
    PyObject *empty_string = 0;
    PyCodeObject *py_code = 0;
    PyFrameObject *py_frame = 0;
    
    py_srcfile = PyString_FromString(__pyx_filename);
    if (!py_srcfile) goto bad;
    py_funcname = PyString_FromString(funcname);
    if (!py_funcname) goto bad;
    py_globals = PyModule_GetDict(__pyx_m);
    if (!py_globals) goto bad;
    empty_tuple = PyTuple_New(0);
    if (!empty_tuple) goto bad;
    empty_string = PyString_FromString("");
    if (!empty_string) goto bad;
    py_code = PyCode_New(
        0,            /*int argcount,*/
        0,            /*int nlocals,*/
        0,            /*int stacksize,*/
        0,            /*int flags,*/
        empty_string, /*PyObject *code,*/
        empty_tuple,  /*PyObject *consts,*/
        empty_tuple,  /*PyObject *names,*/
        empty_tuple,  /*PyObject *varnames,*/
        empty_tuple,  /*PyObject *freevars,*/
        empty_tuple,  /*PyObject *cellvars,*/
        py_srcfile,   /*PyObject *filename,*/
        py_funcname,  /*PyObject *name,*/
        __pyx_lineno,   /*int firstlineno,*/
        empty_string  /*PyObject *lnotab*/
    );
    if (!py_code) goto bad;
    py_frame = PyFrame_New(
        PyThreadState_Get(), /*PyThreadState *tstate,*/
        py_code,             /*PyCodeObject *code,*/
        py_globals,          /*PyObject *globals,*/
        0                    /*PyObject *locals*/
    );
    if (!py_frame) goto bad;
    py_frame->f_lineno = __pyx_lineno;
    PyTraceBack_Here(py_frame);
bad:
    Py_XDECREF(py_srcfile);
    Py_XDECREF(py_funcname);
    Py_XDECREF(empty_tuple);
    Py_XDECREF(empty_string);
    Py_XDECREF(py_code);
    Py_XDECREF(py_frame);
}
